/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gclamp                                                    *
*Project Version: 1.2.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 17th May 2011                                     *
*                                                                           *
*Start DateStamp: 04-May-2009 10.15.10 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:   http://balean.net/linprogs                                         *
*                                                                           *
*Project Summary:                                                           *
* Gtk++ frontend for CLAMav Program                                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       vtesu.cpp                                                 *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       08-Feb-2011 17.02.21 -36000 3600                          *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/
#include <iostream>
#include <sstream>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/wait.h>
#include <errno.h>
#include <ctype.h>
#include <sys/types.h>
#include <pwd.h>

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

// NB: some systems may use this instead:-
//#include <vte/vte.h>
#include <vte-0.0/vte/vte.h>

#include "vtesu.h"
#include "common.h"

using namespace std;


static GtkWidget *vte;
GdkColor Vtesu::red         = {0, 0xffff, 0x0000, 0x0000};

bool Vtesu::parent_quit_flag;
GtkWidget *Vtesu::window;

Vtesu::~Vtesu(void)
{
//cout << "Vtesu::~Vtesu" << endl;
if (pixbuf) g_object_unref(G_OBJECT(pixbuf));
}

void Vtesu::callback_destroy(GtkWidget *widget, Vtesu *vsu)
{
//cout << "Vtesu::callback_destroy" << endl;
gtk_main_quit();
}

void Vtesu::callback_quit(GtkWidget *widget, Vtesu *vsu)
{
//g_print("callback_quit - 1\n");

gtk_widget_destroy(vsu->window);
//cout << "Vtesu::callback_quit - done gtk_widget_destroy" << endl;

}

string Vtesu::itos(int n)
{
ostringstream ost;
ost << n;
return ost.str();
}

// Open a new process, command
int Vtesu::new_process(const char *command)  //, pid_t p)
{

extern char **environ;


pid_t pid;

// NOTE:  pipes -  write into fp[1] and read from fp[0]

if (! (command && *command) ) return(-1);

//  if (pipe(fp)) return(-2);   // NOT USING PIPES

if ((pid = fork()) == -1) return(-3);

if (pid == 0)
  {

  //==============
  // CHILD PROCESS
  //==============

  char *argv[4];
  argv[0] = (char *)"sh";
  argv[1] = (char *)"-c";
  argv[2] = (char *)command;
  argv[3] = 0;

//  cout << "CHILD PROCESS - command= " << command << endl;

  execve("/bin/sh", argv, environ);

  exit(127);                          // Error if it returns...
  }

//===============
// PARENT PROCESS
//===============

//cout << "PARENT PROCESS - command= " << command << endl;

sleep(1);    // give it a moment to start



for(;;)
  {
  int status = 0;

  if (waitpid(pid, &status, 0) == -1)
    {
    if (! (errno == EINTR) ) return(-1);
    }
  else if (WIFEXITED(status))
    {
    status = (WEXITSTATUS(status));

//#ifdef debug
//    cerr << "Leaving NewProcess("<< command << "," << p
//         << "), return code " << status << endl;
//#endif

    return(status);
    }
  else
    {

//#ifdef debug
//   cerr << "Leaving NewProcess("<< command << "," << p
//         << "), UNKNOWN ERROR: status " << status << endl;
//#endif

    return(-4);
    }
  }
}


void Vtesu::callback_ignore(GtkWidget *widget, Vtesu *vsu)
{
//cout << "Vtesu::callback_ignore" << endl;

gtk_label_set_text(GTK_LABEL(vsu->status_label), "");
gtk_main_iteration_do(FALSE);


//cout << "Vtesu::callback_ignore - cmd= " << cmd << endl;

vsu->new_process( (vsu->command + (string)" &\n").c_str() );


// ====================================
// Now check if the command is running
// ====================================

if (vsu->check_running(vsu->command, NULL))
  {
//  cout << "callback_ok - command is running" << endl;
  callback_quit(widget, vsu);
  }
else
  {
  // Command didn't start
//  cout << "callback_ok - command is NOT running" << endl;
  gtk_label_set_text(GTK_LABEL(vsu->status_label), "Failed to run the command... Retry!");
  }

}

bool Vtesu::check_running(string cmd, int *pid)
{
char *c;
int val;
char *endptr;

for (int n=10; n; --n)
  {

  char *plist = (char *)( get_file( (char *)"ps -eo \"%p %a\" --no-headers" ) ).c_str();
  string pid_str = itos(shell_pid);

// cout << plist << endl;
  usleep(100000); // small pause and try again up to 10 times

// cout << "Vtesu::check_running -  pid_str= " << pid_str << endl;
  c = plist;

  while (*c)
    {
    if (atoi(c) == shell_pid)  // The place to start searching
      {
      break;
      }
    while ( (*c) && ( (*c) != '\n') )
      {
      c++;
      }
    if (*c) c++;
    }

//cout << "Vtesu::check_running - command= " << command << endl;
//cout << "  command.length()= " << command.length() << endl;
//cout << "  strlen(command.c_str())= " << strlen(command.c_str()) << endl;
	
//cout << "\nVtesu::check_running - c= \n" << c << endl;


// Now look for the command

  while (*c)
    {
//    while (isblank(*c)) c++;
//    while (isdigit(*c)) c++;
//    while (isblank(*c)) c++;

    val = strtol(c, &endptr, 10);
    c = endptr;

    while (isblank(*c)) c++;

    if (strncmp(c, cmd.c_str(), cmd.length())==0)
      {
//      cout << "Vtesu::check_running -c= " << c << " : cmd= " << cmd << endl;
      if (pid)  // pid of this command
        {
        *pid = val;
        }
      return TRUE;
      }


    while ( (*c) && ( (*c) != '\n') )
      {
      c++;
      }
    if (*c) c++;
    }
   } // for (int n=10; n; --n)

// FAILED
return FALSE;
}


bool Vtesu::is_running_as_root(int pid)
{
// Get a list of pid's run by root
char *plist = (char *)( get_file( (char *)"ps -u root -o \"%p\" --no-headers" ) ).c_str();
char *c = plist;
char *endptr;
int val;

//cout << "Vtesu::is_running_as_root - pid= " << pid << endl;

while (*c)
  {
  val = strtol(c, &endptr, 10);
//  cout << "Vtesu::is_running_as_root - pid= " << pid << " : val= " << val << endl;

  if ( pid == val)
    {
    return TRUE;
    }
  c = endptr;
  while ( (*c) && ( (*c) != '\n') )
    {
    c++;
    }
  if (*c) c++;
  }


return FALSE;
}

bool Vtesu::is_running_as_user(int pid)
{

}

// Pipe output of a command to a buffer
string Vtesu::get_file(string command)
{
string buffer;
FILE *fp;
char pipebuffer[PIPE_BUF];

if ( (fp = popen(command.c_str(), "r")) )
  {
  while ( fgets(pipebuffer, PIPE_BUF, fp) )
    {
    buffer += pipebuffer;
    }

  if (ferror(fp))
    {
    // ERROR CONDITION
    buffer.clear();
    }
  }
else
  {
	// ERROR: can't open pipe
  // Empty string is returned
  }
pclose(fp);
return(buffer);  // returns a zero-terminated string
}

void Vtesu::callback_ok(GtkWidget *widget, Vtesu *vsu)
{
string cmd;

//cout << "Vtesu::callback_ok" << endl;

string password = (string)gtk_entry_get_text(GTK_ENTRY(vsu->password_entry)) + "\n";
vte_terminal_set_color_foreground(VTE_TERMINAL(vte), &common::black);
vte_terminal_set_color_background(VTE_TERMINAL(vte), &common::white);

gtk_label_set_text(GTK_LABEL(vsu->status_label), "");
gtk_main_iteration_do(FALSE);

switch (vsu->start_type)
  {
  case SUSUDO:  // Perfect
    {
//    cout << "Vtesu::callback_ok - case SUSUDO:" << endl;
    
    vte_terminal_feed_child(VTE_TERMINAL(vte), "su\n", -1);

		sleep(1); // Give it time...
		
    if (! vsu->check_running("su", NULL)) // Try this
      {
      gtk_label_set_text(GTK_LABEL(vsu->status_label), "Failed to run the command... Retry! (su didn't start)");
      gtk_entry_set_text(GTK_ENTRY(vsu->password_entry), "");
      return;
      }

    vte_terminal_feed_child(VTE_TERMINAL(vte), password.c_str(), -1);
    
		sleep(1); // Give it time...
		
    cmd = "sudo " + vsu->command + " &\n";
    vte_terminal_feed_child(VTE_TERMINAL(vte), cmd.c_str(), -1);

    break;
    }

  case SU: // OK I think
    {
//    cout << "Vtesu::callback_ok - case SU:" << endl;


    vte_terminal_feed_child(VTE_TERMINAL(vte), "su\n", -1);
    sleep(1);
    if (! vsu->check_running("su", NULL)) // Try this
      {
      gtk_label_set_text(GTK_LABEL(vsu->status_label), "Failed to run the command... Retry! (su didn't start)");
      gtk_entry_set_text(GTK_ENTRY(vsu->password_entry), "");
      return;
      }

    vte_terminal_feed_child(VTE_TERMINAL(vte), ( (string)(password + "\n") ).c_str(), -1);

    sleep(1);         // seems to require a whole second!

    cmd =  vsu->command + " &\n";
    vte_terminal_feed_child(VTE_TERMINAL(vte), cmd.c_str(), -1);


    break;
    }

  case SUDO: // Perfect
    {
 //   cout << "Vtesu::callback_ok - case SUDO:" << endl;

    cmd = "sudo -b " + vsu->command + "\n";
    vte_terminal_feed_child(VTE_TERMINAL(vte), cmd.c_str(), -1);

    sleep(1);

    vte_terminal_feed_child(VTE_TERMINAL(vte), password.c_str(), -1);
 
    break;
    }
  }

usleep(500000); // Give it time to start This doesn't seem to be enough...
sleep(1);				// Give it a bit more!

// ====================================
// Now check if the command is running
// ====================================

// cout << "Vtesu::callback_ok - cmd= " << cmd << " : start_type= " << vsu->start_type << endl;

int command_pid;

if (vsu->check_running(vsu->command, &command_pid))
  {
//  cout << "Vtesu::callback_ok - command is running" << endl;

  if (vsu->is_running_as_root(command_pid))
    {
	//cout << "Vtesu::callback_ok - command is running_as_root - cmd= " << cmd << endl;

	sleep(1);

	vsu->parent_quit_flag = TRUE;
//	callback_quit(widget, vsu);

    gtk_main_quit();
    }
  else
    {

//    cout << "Vtesu::callback_ok - command is running WITHOUT ROOT PRIVELEGES!" << endl; // Authentication failed
//    cout << "                     command_pid= " << command_pid << endl;

    // Kill the command and inform the user about the problem
    if (kill(command_pid, SIGTERM)== -1)
      {
//      cout << "callback_ok - kill failed!" << endl;
      gtk_label_set_text(GTK_LABEL(vsu->status_label), "Authentication failed. The command ran but\nwithout root priveleges. Quit and Retry!");
      gtk_entry_set_text(GTK_ENTRY(vsu->password_entry), "");
      }
    else
      {
      gtk_label_set_text(GTK_LABEL(vsu->status_label), "Authentication failed. The command ran but\nwithout root priveleges and was killed.  Retry!");
      gtk_entry_set_text(GTK_ENTRY(vsu->password_entry), "");
      }
    }
  }
else
  {
  // Command didn't start
  string msg = (string)(((vsu->start_type==SUSUDO)||(vsu->start_type==SU)) ? "su" : "sudo") + (string)" started  but the command failed... Retry!";
//  cout << "callback_ok - command is NOT running" << endl;

  gtk_label_set_text(GTK_LABEL(vsu->status_label), msg.c_str());
  gtk_entry_set_text(GTK_ENTRY(vsu->password_entry), "");
  }
}


bool Vtesu::parse_opts(int argc, char *argv[], string *error)
{
start_type = SUSUDO;          // default
ignore_button_wanted = TRUE;  // default

//cout << "Vtesu::parse_opts" <<  endl;

//int n = 1;
//while (n<argc)
for (int n=0; (n<argc) && (argv[n]); ++n)
  {
//  cout << "parse_opts - n= " << n << " : argc= " << argc << " : argv[n]= " << argv[n] << endl;

// -t
  if (strncasecmp(argv[n], "-t", 2)==0)
    {
    if (title.length() == 0)
      {
      if (strlen(argv[n]) > 2)
        {
        title = &(argv[n])[2];      
        }
      else if ( (argc > n) && (argv[n+1][0] != '-') )
        {
        title = argv[++n];
        }
      else
        {
        // ERROR: -t but no title : not critical
        *error = "parse_opts - ERROR: -t but no title";
        return FALSE;
        }
//     cout << "parse_opts - title= " << title << endl;
      }
    else
      {
      // ERROR: title already defined
      *error = "parse_opts - ERROR: -t but title has already been defined as \"" + title + "\"";
      return FALSE;
      }
    }

// -m
  else if (strncasecmp(argv[n], "-m", 2)==0)
    {
    string msg;

    if (message.length() == 0)
      {
      if (strlen(argv[n]) > 2)
        {
        msg = &(argv[n])[2];
        }
      else if ((argc > n+1) && (argv[n+1][0] != '-'))
        {
        msg = argv[++n];
        }
      else
        {
        // ERROR: -m but no message : not critical
        *error =  "parse_opts - ERROR: -m but no message";
        return FALSE;
        }

      char *c = (char *)msg.c_str();

      while (*c)
        {
        if (strncmp(c, "\\n", 2)==0)
          {
          message += "\n";
          c++;
          }

        else if (strncmp(c, "\\t", 2)==0)
          {
          message += "\t";
          c++;
          }

        else if (strncmp(c, "\\a", 2)==0)
          {
          message += "\a";
          c++;
          }

        else if (strncmp(c, "\\b", 2)==0)
          {
          message += "\b";
          c++;
          }

        else if (strncmp(c, "\\f", 2)==0)
          {
          message += "\f";
          c++;
          }
        else if (strncmp(c, "\\r", 2)==0)
          {
          message += "\r";
          c++;
          }
        else if (strncmp(c, "\\v", 2)==0)
          {
          message += "\v";
          c++;
          }
         else if (strncmp(c, "\\", 2)==0)
          {
          message += "\\";
          c++;
          }
        else if (strncmp(c, "\\?", 2)==0)
          {
          message += "\?";
          c++;
          }
        else if (strncmp(c, "\\'", 2)==0)
          {
          message += "\'";
          c++;
          }
        else if (strncmp(c, "\\\"", 2)==0)
          {
          message += "\"";
          c++;
          }
        else
          {
          message += (*c);
          }
        c++;
        }
      }
    else
      {
      // ERROR: message already defined
      *error = "parse_opts - ERROR: -m but message has already been defined as \"" + message + "\"";
      return FALSE;
      }
    }

// -c
  else if (strncasecmp(argv[n], "-c", 2)==0)
    {
//    cout << "parse_opts - got -c" << endl;

    if (command.length() == 0)
      {      
      if (strlen(argv[n]) > 2)
        {
        command = &(argv[n])[2];      
        }


      while ( (argc > n+1) && (argv[n+1][0] != '-') )
        {
        n++;
        command += ' ';
        command += argv[n];
        }

//      cout << "parse_opts - command= " << command << endl;

      }
    else
      {
      // ERROR: command already defined
      *error = "parse_opts - ERROR: command has already been defined as \"" + command + "\"";
      return FALSE;
      }
    }

// -e
  else if (strncasecmp(argv[n], "-e", 2)==0)
    {
    if  (strlen(argv[n])==3)
      {
      if (argv[n][2]=='1') start_type = SU;
      else if (argv[n][2]=='2') start_type = SUDO;
      else if (argv[n][2] != '0')
        {
        //  ERROR: unrecognised start-type
        *error = "parse_opts - ERROR: unrecognised -e option";
        return FALSE;
        }
      }
    else if ( (strlen(argv[n]) == 2) &&
              (argc > n+1) &&
              (argv[n+1][0] != '-') &&
              (strlen(argv[n+1]) == 1) )
      {
      n++;
      if (*argv[n] == 1) start_type = SU;
      else if (*argv[n] == 2) start_type = SUDO;
      else if (*argv[n] != '0')
        {
        //  ERROR: unrecognised start-type
        *error = "parse_opts - ERROR: unrecognised -e option";
        return FALSE;
        }     
      }
    }

// -ni
  else if (strcasecmp(argv[n], "-ni")==0)
    {
    ignore_button_wanted = FALSE;
    }

// ERROR: unrecognised arg
  else if ((n<argc) && (argv[n][0] == '-'))
    {
    // ERROR: unrecognised arg
    *error = "parse_opts - ERROR: unrecognised arg \"" + (string)argv[n] +  "\"";
    return FALSE;
    }
// default is command
  else if (command.length() == 0)
    {
//    cout <<"parse_opts - n= " << n << " : argc= " << argc << endl;
    command += argv[n];
    
    while ( ((n+1) < argc) && (argv[n+1][0] != '-') )
      {
      command += " ";
      command += argv[++n];
      }
//    cout << "parse_opts - default command= " << command << endl;
    }
  else
    {
    // ERROR: command already defined
    *error = "parse_opts - ERROR: command has already been defined as \"" + command + "\"";
    return FALSE;
    }
//  n++;
  }
return TRUE;
}

gint Vtesu::snoop_func (GtkWidget *grab_widget, GdkEventKey *event, Vtesu *vsu)
{
GtkWidget *f = gtk_window_get_focus(GTK_WINDOW(vsu->window));

if (gtk_window_has_toplevel_focus(GTK_WINDOW(vsu->window)))
  {
  if ( (f==vsu->password_entry) )
    {
    if (event->type == GDK_KEY_PRESS)
      {
      if ((event->keyval == GDK_Return) || (event->keyval == GDK_KP_Enter)) // keyboard and keypad
       {
       // DO IT
       vsu->callback_ok(NULL, vsu);
       return TRUE;
       }
      }
    }
  }
return FALSE; // Do default
}

Vtesu::Vtesu(int argc, char *argv[])
{
GtkWidget *table;
GtkTooltips *tooltips;
GtkWidget *scrolled_window;
GtkWidget *wid, *buttonbox;
long size;
char *buf;
char *ptr;
string status;
string error;

//cout << "Vtesu::Vtesu" << endl;

parent_quit_flag = FALSE;

if ( (argc >= 1) && parse_opts(argc, argv, &error) )
  {
//  cout << "Vtesu::Vtesu 1" << endl;

  user = (getpwuid( getuid() ))->pw_name;
  if (user == "root")
  	{
    string cmd = command + " &\n";

    new_process(cmd.c_str());

		sleep(1); // Give it time to start...

    if (check_running(command, NULL))
      {
//      cout << "Vtesu::Vtesu - command is running" << endl;
      return;
      }
    else
      {
      // Command didn't start
//      cout << "callback_ok - command is NOT running" << endl;
      status = "Already root but failed to run the command... Retry!";
      }
  	}

  
//  gtk_init (&argc, &argv);


  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(GTK_WIDGET(window), 460, 248); //408, 248);    // width, height
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER_ALWAYS);
	gtk_window_set_keep_above(GTK_WINDOW(window), TRUE);
  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (callback_destroy),
		    this);
  gtk_container_set_border_width(GTK_CONTAINER(window), 0);
  if (title.length())
    {
    gtk_window_set_title(GTK_WINDOW(window), title.c_str());
    }
 
  pixbuf = gtk_widget_render_icon(GTK_WIDGET(window),
				  GTK_STOCK_DIALOG_AUTHENTICATION,
				  GTK_ICON_SIZE_DIALOG,
				  "" );
  if (pixbuf)
    {
    gtk_window_set_icon( GTK_WINDOW(window), pixbuf);
    }


//  g_print("Vtesu::Vtesu - window= %08X\n", window);




  if (!message.length())
    {
    message = "Root priveleges have been requested.\nUsing ";
    switch(start_type)
      {
      case SU:
      message += "su.";
      break;

      case SUDO:
      message += "sudo.";
      break;

      case SUSUDO:
      default:
      message += "su and sudo.";
      break;
      }
    }
  table = gtk_table_new(240, 400, TRUE); // rows, columns, homogeneous
  gtk_container_add(GTK_CONTAINER(window), table);


  size = pathconf(".", _PC_PATH_MAX);
  if ((buf = (char *)malloc((size_t)size)) != NULL) ptr = getcwd(buf, (size_t)size);
  else ptr = NULL;

  wid = gtk_image_new_from_stock(GTK_STOCK_DIALOG_AUTHENTICATION, GTK_ICON_SIZE_DIALOG);
  gtk_table_attach(GTK_TABLE(table), wid,
		   10, 60, 10, 60,
		   /* left attach, right attach, top attach, bottom attach */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* xoptions */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* yoptions */
		   0, 0);
		   /* xpadding, ypadding */




// Message
  wid = gtk_label_new(message.c_str());
  gtk_misc_set_alignment(GTK_MISC (wid), 0, .5);
  gtk_table_attach(GTK_TABLE(table), wid,
		   60, 390, 0, 60,
		   /* left attach, right attach, top attach, bottom attach */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* xoptions */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* yoptions */
		   0, 0);                                         
		   /* xpadding, ypadding */

// Command
  wid = gtk_label_new( ((string)("Command:   " + command)).c_str() );
  gtk_misc_set_alignment(GTK_MISC (wid), 0, .5);
  gtk_table_attach(GTK_TABLE(table), wid,
		   10, 390, 60, 100,
		   /* left attach, right attach, top attach, bottom attach */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* xoptions */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* yoptions */
		   0, 0);                                         
		   /* xpadding, ypadding */

  tooltips = gtk_tooltips_new();

// Password
  wid = gtk_label_new(((string)("Password for " + ( (start_type == SUDO) ? user : "root") + ":")).c_str());

  gtk_misc_set_alignment(GTK_MISC(wid), 0, .5);
  gtk_table_attach(GTK_TABLE(table), wid,
		   10, 180, 100, 140,
		   /* left attach, right attach, top attach, bottom attach */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* xoptions */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* yoptions */
		   0, 0);                                         
		   /* xpadding, ypadding */
  


  password_entry = gtk_entry_new();
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), password_entry,
      ((string)("Password\nEnter " + ( (start_type == SUDO) ? user : "root") + "'s password")).c_str(),
      NULL);
  gtk_entry_set_visibility(GTK_ENTRY(password_entry), FALSE);
  gtk_table_attach(GTK_TABLE(table), password_entry,
		   180, 390, 100, 140,
		   /* left attach, right attach, top attach, bottom attach */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* xoptions */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* yoptions */
		   0, 0);                                         
		   /* xpadding, ypadding */

// To cause "ENTER" to work as "OK"
  gtk_key_snooper_install( (GtkKeySnoopFunc)snoop_func, (gpointer)this);

// Status
  status_label = gtk_label_new(status.c_str());
  gtk_misc_set_alignment(GTK_MISC (status_label), 0, 1);
  gtk_widget_modify_fg(GTK_WIDGET(status_label), GTK_STATE_NORMAL, &red);
  gtk_table_attach(GTK_TABLE(table), status_label,
		   10, 390, 140, 180,
		   /* left attach, right attach, top attach, bottom attach */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* xoptions */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* yoptions */
		   0, 0);
		   /* xpadding, ypadding */


  buttonbox = gtk_hbutton_box_new();
  gtk_button_box_set_layout(GTK_BUTTON_BOX(buttonbox), GTK_BUTTONBOX_EDGE);// GTK_BUTTONBOX_SPREAD);
  gtk_box_set_spacing(GTK_BOX(buttonbox), 0);

  gtk_table_attach(GTK_TABLE(table),buttonbox,
		   10, 390, 180, 240,
		   /* left attach, right attach, top attach, bottom attach */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* xoptions */
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   /* yoptions */
		   0, 0);
		   /* xpadding, ypadding */






// OK BUTTON
  wid = gtk_button_new_with_label("OK, Do It");
  gtk_button_set_image(GTK_BUTTON(wid ), gtk_image_new_from_stock(GTK_STOCK_OK, GTK_ICON_SIZE_BUTTON));

  g_signal_connect(G_OBJECT(wid), "clicked",
		    	G_CALLBACK(callback_ok),  this);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), wid,
      "OK, Do It\n"
      "Use the entered password",
      NULL);
  gtk_container_add(GTK_CONTAINER(buttonbox), wid);

  gtk_widget_show(GTK_WIDGET(gtk_button_get_image(GTK_BUTTON(wid))));

// IGNORE BUTTON
  if (ignore_button_wanted)
    {
    wid = gtk_button_new_with_label("Ignore");
//  gtk_button_set_image(GTK_BUTTON(wid ), gtk_image_new_from_stock(GTK_STOCK_OK, GTK_ICON_SIZE_BUTTON));
    gtk_button_set_image(GTK_BUTTON(wid ), gtk_image_new_from_stock(GTK_STOCK_EXECUTE, GTK_ICON_SIZE_BUTTON));

    g_signal_connect(G_OBJECT(wid), "clicked",
		    	G_CALLBACK(callback_ignore),  this);
    gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), wid,
      "Ignore\n"
      "Execute the command without authorisation",
      NULL);
    gtk_container_add(GTK_CONTAINER(buttonbox), wid);
    gtk_widget_show(GTK_WIDGET(gtk_button_get_image(GTK_BUTTON(wid))));
    }

// CANCEL BUTTON
  wid = gtk_button_new_from_stock(GTK_STOCK_CANCEL);
//  gtk_button_set_image(GTK_BUTTON(wid ), gtk_image_new_from_stock(GTK_STOCK_CANCEL, GTK_ICON_SIZE_BUTTON));
  g_signal_connect(G_OBJECT(wid), "clicked",
		    	G_CALLBACK(callback_quit),  NULL);

  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), wid,
      "Cancel\n"
      "Terminate the program",
      NULL);
  gtk_container_add(GTK_CONTAINER(buttonbox), wid);
  gtk_widget_show(GTK_WIDGET(gtk_button_get_image(GTK_BUTTON(wid))));


  gtk_widget_show_all(window);



// From here on should be invisible
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
																GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  gtk_table_attach(GTK_TABLE(table), scrolled_window,
		   10, 190, 10, 120,
//		   10, 190, 210, 320,
		   // left attach, right attach, top attach, bottom attach
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   // xoptions
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   // yoptions
		   0, 0);                                         
		   // xpadding, ypadding
//  
//    gtk_widget_show_all(window);

/*
wid = gtk_vbox_new(TRUE, 0);

gtk_table_attach(GTK_TABLE(table), wid,
		   10, 100, 10, 120,
		   // left attach, right attach, top attach, bottom attach
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   // xoptions
		   (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
		   // yoptions
		   0, 0);                                         
		   // xpadding, ypadding
*/
/*
pid_t               vte_terminal_fork_command           (VteTerminal *terminal,
                                                         const char *command,
                                                         char **argv,
                                                         char **envv,
                                                         const char *working_directory,
                                                         gboolean lastlog,
                                                         gboolean utmp,
                                                         gboolean wtmp);

gboolean            vte_terminal_fork_command_full      (VteTerminal *terminal,
                                                         VtePtyFlags pty_flags,
                                                         const char *working_directory,
                                                         char **argv,
                                                         char **envv,
                                                         GSpawnFlags spawn_flags,
                                                         GSpawnChildSetupFunc child_setup,
                                                         gpointer child_setup_data,
                                                         GPid *child_pid,
                                                         GError **error);
*/
//

  vte = vte_terminal_new();
  vte_terminal_set_background_transparent(VTE_TERMINAL(vte), FALSE);
  vte_terminal_set_size(VTE_TERMINAL(vte), 80, 25);

/**/
#if VTE_CHECK_VERSION(0,25,1)
  char **a = 0;
  g_shell_parse_argv("/bin/sh", 0, &a, 0);
  vte_terminal_fork_command_full(VTE_TERMINAL(vte), (VtePtyFlags)0, ptr, a, 0, (GSpawnFlags)0, 0, 0, &shell_pid, 0);
  g_print("Using vte_terminal_fork_command_full\n");
#else

  shell_pid = vte_terminal_fork_command(VTE_TERMINAL(vte), NULL, NULL, NULL, NULL, FALSE, FALSE, FALSE);
  g_print("Using OBSELETE vte_terminal_fork_command\n");
#endif

  vte_terminal_set_scroll_on_keystroke(VTE_TERMINAL (vte), TRUE);
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_window), vte);

//
//  cout << "Vtesu::Vtesu - pid= " << pid << endl;  // This is the pid of /bin/sh if full, othewise /bin/bash
//  gtk_widget_show_all(window);

gtk_main ();
//  gtk_main_iteration_do(FALSE);

  }
else
  {
  cout << endl << error << endl;
  cout << "\nUsage:\n  vtesu [Options] command\n"
       << "    Only \"command\", the command to be executed with root priveleges,\n"
       << "    is mandatory. The options all have sensible defaults.\n"
       << "  Options\n"
       << "    -e0        : Use su and sudo to gain authorisation. This is the default.\n"
       << "               : Note that the root user doesn't require authorisation with sudo.\n"
       << "    -e1        : Use su alone to gain authorisation. Some commands may not execute.\n"
       << "    -e2        : Use sudo alone to gain authorisation.\n\n"
       << "    -cCOMMAND  :  - OR:-\n"
       << "    -c COMMAND : Specify the command to be executed as root.\n"
       << "               : Note: -c can be omitted as \"COMMAND\" is the default.\n\n"
       << "    -tTITLE    :  - OR:-\n"
       << "    -t TITLE   : Use \"TITLE\" as the windows title.\n\n"
       << "    -mMESSAGE  :  - OR:-\n"
       << "    -m MESSAGE : Use \"MESSAGE\" as the windows message.\n"
       << "               : Note: this appears near the top of the window.\n\n"
       << "    -ni        : Omit the \"Ignore\" button from the display.\n\n"
       << "EXAMPLES:-\n"
       << "  vtesu xemacs /root/Documents/TEST -ni\n"
       << "      assuming that xemacs is installed and /root/Documents/TEST exists.\n"
       << "  vtesu -m \'Welcome\\nUsing su and sudo\' -t \'SU plus SUDO\' -cgedit /root/Documents/TEST2\n"
       << "      NOTE that the title and message have to be in quotes.\n\n";

  }       
}

