/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gclamp                                                    *
*Project Version: 1.2.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 17th May 2011                                     *
*                                                                           *
*Start DateStamp: 04-May-2009 10.15.10 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:   http://balean.net/linprogs                                         *
*                                                                           *
*Project Summary:                                                           *
* Gtk++ frontend for CLAMav Program                                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       vtesu.h                                                   *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       26-Dec-2010 15.19.47 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header for vtesu.cpp                                                      *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __VTESU_H__
#define __VTESU_H__

#include <iostream>
#include <string>

using namespace std;

enum {SUSUDO, SU, SUDO};

class Vtesu
{
public:
  Vtesu(int argc, char *argv[]);
  ~Vtesu(void);

  static bool parent_quit_flag;
  static GtkWidget *window;

private:
  static void callback_ok(GtkWidget *widget, Vtesu *vsu);
  static void callback_destroy(GtkWidget *widget, Vtesu *vsu);
  static void callback_quit(GtkWidget *widget, Vtesu *vsu);
  static void callback_ignore(GtkWidget *widget, Vtesu *vsu);

  static gint snoop_func (GtkWidget *grab_widget, GdkEventKey *event, Vtesu *vsu);
  int new_process(const char *command);

  string get_file(string command);
  bool parse_opts(int argc, char *argv[], string *error);
  bool check_running(string cmd, int *pid);
  bool is_running_as_root(int pid);
  bool is_running_as_user(int pid);

  string itos(int n);  // Probably not needed...

  GdkPixbuf *pixbuf;

  GtkWidget *status_label;
  GtkWidget *password_entry;
  string user;

  int shell_pid;        // pid of the shell (/bin/sh  or  /bin/bash)
  int start_type;
  string title;
  string message;
  string command;
  static GdkColor red;

  bool ignore_button_wanted;


protected:

};

#endif // __VTESU_H__
