/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gclamp                                                    *
*Project Version: 1.2.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 17th May 2011                                     *
*                                                                           *
*Start DateStamp: 04-May-2009 10.15.10 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:   http://balean.net/linprogs                                         *
*                                                                           *
*Project Summary:                                                           *
* Gtk++ frontend for CLAMav Program                                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       gclamp.cpp                                                *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       15-Feb-2011 22.41.01 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* The part that does all the work...                                        *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/
#include <iostream>
#include <fstream>
#include <sstream>

#include <stdlib.h>
#include <sys/stat.h>
#include <errno.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <pwd.h>
#include <fcntl.h>
#include <limits.h>

#include "../common/common.h"
#include "../common/vtesu.h"

#include "logfile.h"
#include "gclamp.h"
#include "data.h"
#include "RH_version.h"

//#include <pthread.h>

using namespace std;
using namespace common;

/*
GdkColor Gclamp::red   = {0, 0xffff, 0x0000, 0x0000};
GdkColor Gclamp::white = {0, 0xffff, 0xffff, 0xffff};
GdkColor Gclamp::blue  = {0, 0x0000, 0x0000, 0xffff};
GdkColor Gclamp::black = {0, 0x0000, 0x0000, 0x0000};

GdkColor Gclamp::pink       = {0, 0xffff, 0xb000, 0xffff};
GdkColor Gclamp::lightblue  = {0, 0xbfff, 0xbfff, 0xffff};
GdkColor Gclamp::lightgreen = {0, 0xbfff, 0xffff, 0xbfff};
//GdkColor Gclamp::cyan       = {0, 0xa000, 0xffff, 0xffff};
//GdkColor Gclamp::lightcyan       = {0, 0xe000, 0xffff, 0xffff}; // not bad
//GdkColor Gclamp::yellow       = {0, 0xffff, 0xffff, 0x0000};
GdkColor Gclamp::lightyellow = {0, 0xffff, 0xffff, 0xbfff};
//GdkColor Gclamp::orange = {0, 0xffff, 0x9999, 0x0000};

GdkColor Gclamp::lightbrown       = {0, 0xe000, 0xb000, 0x9000};
*/

string Gclamp::Want_Log_TXT               = "WANT_Log";
string Gclamp::Append_Log_TXT             = "APPEND_Log";
string Gclamp::Log_Empty_Files_TXT        = "LOG_Empty_Files";
string Gclamp::Log_OK_Files_TXT           = "LOG_OK_Files";
string Gclamp::Log_Excluded_Files_TXT     = "LOG_Excluded_Files";
string Gclamp::Browser_Command_TXT        = "Browser_Command";
string Gclamp::Use_Su_TXT                 = "USE_Su";
string Gclamp::Su_Timeout_TXT             = "SU_Timeout";
string Gclamp::Action_TXT                 = "ACTION";
string Gclamp::Warn_Days_TXT              = "WARN_Days";
string Gclamp::Auto_Update_Days_TXT       = "UPDATE_Days";
string Gclamp::Start_Directories_TXT      = "START_Directories";
string Gclamp::End_Directories_TXT        = "END_Directories";
string Gclamp::Start_Directories_Omit_TXT = "START_Directories_Omit";
string Gclamp::End_Directories_Omit_TXT   = "END_Directories_Omit";
string Gclamp::Start_Files_TXT            = "START_Files";
string Gclamp::End_Files_TXT              = "END_Files";
string Gclamp::Start_Files_Omit_TXT       = "START_Files_Omit";
string Gclamp::End_Files_Omit_TXT         = "END_Files_Omit";

string Gclamp::month_names[]          = {
                                        "Jan",
                                        "Feb",
                                        "Mar",
                                        "Apr",
                                        "May",
                                        "Jun",
                                        "Jul",
                                        "Aug",
                                        "Sep",
                                        "Oct",
                                        "Nov",
                                        "Dec"
                                        };


string Gclamp::freshclam_log_warning =
  "NOTE:\n"
  "Make sure that clamav, clamav-filesystem, clamav-lib, clamav-data,\n"
  "  and clamav-update are all installed properly.\n"
  "The log file freshclam.log must exist at  /var/log/freshclam.log.\n"
  "This is the default in /etc/freshclam.conf.\n"
  "If not already fixed, it may be be required to do the following as root:-\n"
  "# groupadd clamav\n"
  "# useradd -g clamav -s /bin/false -c \"Clam AntiVirus\" clamav\n"
  "# touch /var/log/freshclam.log\n# chmod 0666 /var/log/freshclam.log\n\n"
  "ALSO in file /etc/freshclam.conf:-\n"
  "  Edit to comment out \"Example\"\n"
  "  Enable \"UpdateLogFile /var/log/freshclam\" by removing \"#\"\n"
  "  Fix DatabaseMirror with country code\n\n"
  "Make very sure everyone has read and write access for \"/var/log/freshclam.log\"\n"
  "  and for \"/tmp\"";

string Gclamp::freshclam_log_fname = "/var/log/freshclam.log";

GtkWidget *Gclamp::load_image   = NULL;
GdkPixbuf *Gclamp::icon_pixbuf  = NULL;
GtkWidget *Gclamp::save_image   = NULL;

GdkPixbuf *Gclamp::rw_pixbuf[]  = { 0, 0, 0, 0, 0, 0, 0 };

GdkPixbuf *Gclamp::blank_pixbuf = NULL;

guint Gclamp::visible_signal;
bool Gclamp::do_scan_all = FALSE;

GtkWidget *Gclamp::warning_label;
GtkWidget *Gclamp::status_label;
GtkWidget *Gclamp::db_status_label;
GtkWidget *Gclamp::summary_label;
string Gclamp::summary;


void Gclamp::callback_quit(GtkWidget *widget, gpointer data)
{
exit(EXIT_SUCCESS);
}


void Gclamp::callback_browse(GtkWidget *widget, Gclamp *g)
{
//cout << "callback_browse" << endl;
g->get_info_from_widgets(g); // The user may have chnged it...
if (g->browser_command.length())
  {
  string command = g->browser_command + " \'" + g->gclamp_doc_pathname + "\'";
  system(command.c_str());
  }
}

void Gclamp::callback_about(GtkWidget *widget, Gclamp *g)
{
//cout << "callback_about" << endl;

if (g->view_about == NULL)
  {
  string text = RH_VERSION_STRING;
  text += "\n";
  text +=  RH_PROJECT_CONTACT;
  text +=   "\n\n";

  text +=  RH_PROJECT_COPYRIGHT;
  text += "\n\n";

  g->view_about = new View(g, "About", text);
  }
}

bool Gclamp::isdir(string pathname)
{
struct stat64 statbuf;
if (! (lstat64(pathname.c_str(), &statbuf)) )
  {
  if (S_ISDIR(statbuf.st_mode))
	  {
	  return(TRUE);
	  }
  }
return FALSE;
}

bool Gclamp::isfile(string pathname, off_t *file_size)
{
struct stat64 statbuf;

// cout << "Gclamp::isfile - pathname= " << pathname << endl;

if (!(lstat64(pathname.c_str(), &statbuf)))
  {

// cout << "Gclamp::isfile - lstat ok" << endl;

  if (S_ISREG(statbuf.st_mode))
    {
// cout << "Gclamp::isfile - S_ISREG ok" << endl;

    if (file_size)  *file_size = statbuf.st_size;
    return(TRUE);
    }
  }
return(FALSE); // Not a regular file or ERROR
}


void Gclamp::fix_db_status(bool want_summary, Gclamp *g)
{
int days = g->get_db_days(g);
if (days < 0)
  {
  // ERROR - NO DATABASE! 
  gtk_label_set_text(GTK_LABEL(g->db_status_label), "ERROR: No database?");
  gtk_widget_modify_fg(GTK_WIDGET(g->db_status_label), GTK_STATE_NORMAL, &red);
  if (want_summary)
    {
    gtk_label_set_label(GTK_LABEL(g->summary_label), freshclam_log_warning.c_str());
    gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &red);
    }
  }
else 
  {
  string msg = "Database date: " + g->get_db_date(g);
  gtk_label_set_text(GTK_LABEL(g->db_status_label), msg.c_str());
  if ((days >= g->warn_days) || ((g->update_days>0) && (days >= g->update_days)) )
    {
    gtk_widget_modify_fg(GTK_WIDGET(g->db_status_label), GTK_STATE_NORMAL, &red);
    }
  else
    {
    gtk_widget_modify_fg(GTK_WIDGET(g->db_status_label), GTK_STATE_NORMAL, &black);
    }
  }
}


// Open a new process, command
// Add a pipe to deal with stderr output from the new process
// What about stdout?
// SCAN VERSION with pipe
int Gclamp::scan_process(string command, Gclamp *g)
{
pid_t pid;
char buffer[PIPE_BUF];
int len;
int fd[2];
FILE *fp;
char *p;
string info;

// NOTE:  pipes -  write into fd[1] and read from fd[0]

if (!command.length()) return(-1);

if (pipe(fd)) return(-2);

if ((pid = fork()) == -1) return(-3);
                                          //==============
if (pid == 0)                            // CHILD PROCESS
  {                                       //==============
  char *argv[4];
  argv[0] = (char *)"sh";
  argv[1] = (char *)"-c";
  argv[2] = (char *)command.c_str();
  argv[3] = 0;
     
//      dup2(fd[1], 2);                     // duplicate stderr

  dup2(fd[1], 1);                     // duplicate stout
  close(fd[0]);                       // Child is not reading
    
  execve("/bin/sh", argv, environ);

  exit(127);                          // Error if it returns...
  }

//===============
// PARENT PROCESS
//===============

// I think we have to read the pipe here
close(fd[1]);                         // Parent is not writing

fp = fdopen(fd[0], "rb");
while ( fgets(buffer, PIPE_BUF, fp) ) //(n = read(fd[0], buffer, BUFSIZE)) )
  {
  len = strlen(buffer);

//  cout << buffer;

  if (buffer[len-1] == '\n') buffer[len-1] = '\0';

  if (buffer[0] == '/')
    {
    p = &buffer[strlen(buffer)-1];
    while ( (p > buffer) )
      {
      info = *p + info;
      if ((*p) == ':') break;
      p--;
      }

//    cout << "\r" << buffer << "                          ";
    if ((*p) == ':')
      {
//      *p = 0;
      current_file = buffer;

      if (info.substr(0,4) == ": OK")
        {
        if (g->log_OK_files) g->logfile->write2log(current_file);
        g->num_scanned++;
        }
      else if (info.substr(0,12) ==  ": Empty file")
        {
        if (g->log_empty_files) g->logfile->write2log(current_file);
        g->num_empty++;
        g->num_scanned++;
        }
      else if (info.substr(0, 10) == ": Excluded")
        {
        if (g->log_excluded_files) g->logfile->write2log(current_file);
        g->num_excluded++; 
        }
      else if (info.substr(0, 23) == ": Can't read file ERROR")
        {
        g->logfile->write2log(current_file);
        g->num_read_errors++;
        }
      else if (info.substr(0, 21) == ": Can't open directory")
        {
        g->logfile->write2log(current_file);
        g->num_open_errors++;
        }
      else if (info.substr(0, 15) == ": Access denied")
        {
        g->logfile->write2log(current_file);
        g->num_denied++;
        }
      else g->logfile->write2log(current_file); // Don't know this one...
      *p = 0;
      current_file = buffer;
      }    
    }
  else if (strncasecmp(buffer, "Infected files: ", 16)==0)
    {
    int i = atoi(&buffer[16]);
    g->num_infected += i;
    }
  else if (strncasecmp(buffer, "Known viruses: ", 15)==0)
    {
    g->known_viruses = &buffer[15];
    }
  else if (strncasecmp(buffer, "Engine version: ", 16)==0)
    {
    g->engine_version = &buffer[16];
    }
  else if (strncasecmp(buffer, "Data scanned: ", 14)==0)
    {
    g->data_scanned += strtod(&buffer[14], NULL);
    }
  else if (strncasecmp(buffer, "Data read: ", 11)==0)
    {
    g->data_read += strtod(&buffer[11], NULL);
    }
  }
fclose(fp);
close(fd[0]);


for (;;)                                 // Parent process
  {
  int status = 0;

  if (waitpid(pid, &status, 0) == -1)
    {
	  if (!(errno == EINTR)) return(-1);
    }
  else if (WIFEXITED(status))
    {
	  status = (WEXITSTATUS(status));

	  return(status);
    }
  else
    {
	  return(-4);
    }
  }
}


// Pipe output of a command to a string buffer
string Gclamp::get_file(string command)
{
string buffer;
FILE *fp;
char pipebuffer[PIPE_BUF];

if ( (fp = popen(command.c_str(), "r")) )
  {
  while ( fgets(pipebuffer, PIPE_BUF, fp) )
    {
    buffer += pipebuffer;
    }

  if (ferror(fp))
    {
    // ERROR CONDITION
    buffer.clear();
    }
  }
else
  {
	// ERROR: can't open pipe
  // Empty string is returned
  }
pclose(fp);
return(buffer);  // returns a zero-terminated string
}


void Gclamp::scan_file(string pathname, Gclamp *g)
{
//int rc;
list<string>::iterator s;

string message = pathname;

//string command = "clamscan --no-summary " + pathname;  //--quiet " + file;   // + " 2 > 1"; // + " > /dev/null";
string command = "clamscan ";

//--exclude=PATT
for (s=g->files_omit.begin(); s!=g->files_omit.end(); ++s)
  {
  command += "--exclude='" + *s + "' ";
  }
command += "--exclude-dir='" + g->quarantine_directory + "' ";

for (s=directories_omit.begin(); s!=directories_omit.end(); ++s)
  {
  command += "--exclude-dir='" + *s + "' ";
  }


if ((g->infected_action) == action(COPY))
  {
  command += "--copy=" + quarantine_directory + " "; 
  }
else if ((g->infected_action) == action(MOVE))
  {
  command += "--move=" + quarantine_directory + " "; 
  }
else if ((g->infected_action) == action(DELETE))
  {
  command += "--remove "; 
  }

command += "'" + pathname;  //--quiet " + file;   // + " 2 > 1"; // + " > /dev/null";

command += "' 2>/dev/null &"; 
//command += " 2>1 &"; 
  
//rc = 
g->scan_process(command, g);

//rc = system(command.c_str());

//cout << "rc= " << rc  << endl;
}


void Gclamp::scan_directory(Directory directory, Gclamp *g)
{
list<string>::iterator s;

string command = "clamscan "; //--quiet ";

if (directory.recursive)
  {
  command += "-r ";
  }

if (!g->scan_all)
  {
  //--exclude=PATT

  for (s=g->files_omit.begin(); s!=g->files_omit.end(); ++s)
    {
    command += "--exclude='" + *s + "' ";
    }

  //--exclude-dir=PATT
  command += "--exclude-dir='" + g->quarantine_directory + "' ";

  for (s=directories_omit.begin(); s!=directories_omit.end(); ++s)
    {
    command += "--exclude-dir='" + *s + "' ";
    }
  }

command += "--exclude-dir='" + g->quarantine_directory + "' ";

if ((g->infected_action) == action(COPY))
  {
  command += "--copy=" + quarantine_directory + " "; 
  }
else if ((g->infected_action) == action(MOVE))
  {
  command += "--move=" + quarantine_directory + " "; 
  }
else if ((g->infected_action) == action(DELETE))
  {
  command += "--remove "; 
  }


command += "'" + directory.name; // + " 2>1";;
  
command += "' 2>/dev/null &"; 

//command += " 2>1 &"; 
  

g->scan_process(command, g);

}

// return TRUE (ONLY use FALSE if the timer should stop and be removed)
gboolean Gclamp::busy_world(gpointer gdata)
{
Gclamp *g = (Gclamp *)gdata;

//cout << "Gclamp::busy_world " << g->world_num << endl;

if (g->world_num > 6) g->world_num = 0;

//cout << "Gclamp::busy_world" << endl;

//gtk_image_set_from_pixbuf(GTK_IMAGE(g->busy_image), g->rw_pixbuf[g->world_num++]);
gtk_image_set_from_pixbuf(GTK_IMAGE(g->gclamp_image), g->rw_pixbuf[g->world_num++]);

gtk_label_set_label(GTK_LABEL(g->current_file_label), g->current_file.c_str());
gtk_label_set_label(GTK_LABEL(g->scanned_label), g->itos(g->num_scanned).c_str());
gtk_label_set_label(GTK_LABEL(g->infected_label), g->itos(g->num_infected).c_str());
if (g->num_infected)
  {
  gtk_widget_modify_fg(GTK_WIDGET(g->infected_label), GTK_STATE_NORMAL, &red);
  }
    
if (!g->busy)
  {
  //cout << "Gclamp::busy_world - stopping timer" << endl;
  g->stop_timer(g);
  return(FALSE);      
  }

return TRUE;
}

void Gclamp::start_timer(Gclamp *g)
{
if (!g->timer)
  {
  // These are milliseconds, not microseconds
  g->timer = g_timeout_add(200, busy_world, (gpointer)g);
 // if (g->timer) cout << "Gclamp::start_timer - timer started" << endl;
  }
}

void Gclamp::stop_timer(Gclamp *g)
{
if (g->timer)
  {
//  gtk_image_set_from_pixbuf(GTK_IMAGE(g->busy_image), g->blank_pixbuf);
  gtk_image_set_from_pixbuf(GTK_IMAGE(g->gclamp_image), g->icon_pixbuf);
  gtk_label_set_label(GTK_LABEL(g->summary_label), g->summary.c_str());
  g_source_remove(g->timer);
  g->timer = 0;
  gtk_grab_remove( g->gclamp_image );
  }
}

int Gclamp::do_scan(void *gclamp)
{  
Gclamp *g = (Gclamp *)gclamp;

string msg;
int seconds, minutes, hours, days;
string warning = "WARNING: ";

g->logfile = new Logfile(g);

//cout << "Gclamp::callback_scan" << endl;

g->logfile->open();

g->data_scanned = g->data_read = g->num_scanned =
    g->num_denied = g->num_read_errors = g->num_open_errors =
    g->num_excluded = g->num_empty = g->num_infected = 0;
g->current_file.clear();
gtk_label_set_label(GTK_LABEL(g->scanned_label), "0");
gtk_label_set_label(GTK_LABEL(g->infected_label), "0");
gtk_label_set_label(GTK_LABEL(g->current_file_label), "");
gtk_label_set_label(GTK_LABEL(g->warning_label), "");

gtk_widget_modify_fg(GTK_WIDGET(g->infected_label), GTK_STATE_NORMAL, &black);
	
g->get_info_from_widgets(g);

if (g->scan_all)
  {
  Directory d;
  d.recursive = TRUE;
  d.name = "/";
  gtk_label_set_label(GTK_LABEL(g->status_label), "Executing SCAN (whole computer)");

  sleep(1);
  g->scan_directory(d, g);  // This causes it to bomb out but why? OK if it starts as root. NEEDS SLEEP!
  }
else
  {
  gtk_label_set_label(GTK_LABEL(g->status_label), "Executing SCAN");

  // Files
  list<string>::iterator f;

  for (f=g->files.begin(); f!=g->files.end(); ++f)
    {
    g->scan_file(*f, g);
    }



  // Directories
  list<Directory>::iterator d;
  for (d=g->directories.begin(); d!=g->directories.end(); ++d)
    {
    gtk_label_set_label(GTK_LABEL(g->current_file_label), "");
    //g->scan_directory(g, (*d).name, (*d).recursive);
    g->scan_directory((*d), g);
    }
  }

seconds = time(NULL) - g->start_time;
minutes = seconds / 60;
seconds %= 60;
hours = minutes / 60;
minutes %= 60;
  
// Scan Summary here
g->logfile->write2log(msg="\n----------- SCAN SUMMARY -----------");
g->summary += msg + "\n";
  
msg = "Known viruses: " + g->known_viruses;
g->logfile->write2log(msg);
g->summary += msg + "\n";


msg = "Engine version: " + g->engine_version;
g->logfile->write2log(msg);
g->summary += msg + "\n";

// Check the database date here
// If none we are in trouble!
// Put whatever in the db label
msg = "Database date: " + g->get_db_date(g);
g->logfile->write2log(msg);
g->summary += msg+ "\n";

msg = "Scanned files: " + g->itos(g->num_scanned);
g->logfile->write2log(msg);
g->summary += msg + "\n";

msg = "Empty files included in scan: " + g->itos(g->num_empty);
g->logfile->write2log(msg);
g->summary += msg + "\n";

msg = "Files excluded: " + g->itos(g->num_excluded);
g->logfile->write2log(msg);
g->summary += msg + "\n";

msg = "Access denied: " + g->itos(g->num_denied);
g->logfile->write2log(msg);
if (g->num_denied)
  {
  warning += msg;
  gtk_label_set_label(GTK_LABEL(g->warning_label), warning.c_str());
  }
g->summary += msg + "\n";

msg = "Files not read ERROR: " + g->itos(g->num_read_errors);
g->logfile->write2log(msg);
g->summary += msg + "\n";

msg = "Directories not opened ERROR: " + g->itos(g->num_open_errors);
g->logfile->write2log(msg);
g->summary += msg + "\n";

msg = "Infected files: " + g->itos(g->num_infected);
g->logfile->write2log(msg);
g->summary += msg + "\n";


msg = "Data scanned: " + g->dtos(g->data_scanned) + " MB";
g->logfile->write2log(msg);
g->summary += msg + "\n";


msg = "Data read: " + g->dtos(g->data_read) + " MB";
g->logfile->write2log(msg);
g->summary += msg + "\n";


msg = "Time: ";
if (hours) msg += g->itos(hours) + " hours ";
msg += g->itos(minutes) + " minutes ";
msg += g->itos(seconds) + " seconds";
g->logfile->write2log(msg);
g->summary += msg + "\n";

  
g->logfile->write2log(msg="---------FINISHED SCANNING----------\n\n");
g->summary += msg;
  
//cout << g->summary;

delete g->logfile;

g->logfile = NULL;

g->busy = FALSE;

gtk_label_set_text(GTK_LABEL(g->status_label), "SCAN COMPLETED");

g->fix_db_status(FALSE, g);
return(0);
}


void Gclamp::callback_scan(GtkWidget *widget, Gclamp *g)
{
if (g->busy) return;

gtk_grab_add( g->gclamp_image );


pthread_t thread;
g->start_time = time(NULL);
g->scan_all = FALSE;
g->busy = 1;
g->summary.clear();
gtk_label_set_label(GTK_LABEL(g->summary_label), "");
gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &black);

if ( pthread_create(
                   &thread,
                   NULL,
                   (void *(*)(void *))do_scan,
                   (void *)g
                   ) )
  {
  cerr << "New thread for scan failed" << endl;
  gtk_label_set_label(GTK_LABEL(g->summary_label), "New thread for scan failed");
  g->busy = 0;
  }
else
  {
  g->start_timer(g);
  }
}

void Gclamp::callback_scan_all(GtkWidget *widget, Gclamp *g)
{
if (g->busy) return;

if ( (strcmp( (getpwuid( getuid() ))->pw_name , "root" )) ) // if we are not root
  {
  string msg;

  // restart as root with scan all command
  gtk_label_set_label(GTK_LABEL(g->summary_label), "");
  gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &black);
 
  g->data_scanned = g->data_read = g->num_scanned = g->num_denied = g->num_infected = 0;
  gtk_label_set_label(GTK_LABEL(g->scanned_label), "0");
  gtk_label_set_label(GTK_LABEL(g->infected_label), "0");
  gtk_label_set_label(GTK_LABEL(g->current_file_label), "");
  gtk_label_set_label(GTK_LABEL(g->warning_label), "");

  gtk_widget_modify_fg(GTK_WIDGET(g->infected_label), GTK_STATE_NORMAL, &black);

/***
  if (!g->have_su_command(msg, g))
    {  
    gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT SCANNED");
    gtk_label_set_label(GTK_LABEL(g->status_label), msg.c_str());
    g->fix_db_status(TRUE, g);
    return;
    }
***/
    
 /* char *array[7] =
  		{
  		(char *)g->gclamp_pathname.c_str(),
  		(char *)g->home_directory.c_str(),
  		(char *)"RESTART",
  		(char *)"SCAN_ALL",
  		(char *)"-e0",         // g->su_command.c_str(),
  		(char *)"-ni",
  		(char *)NULL
  		};
*/
  char *array[7] = // { NULL };
  		/* */
  		{
  		(char *)g->gclamp_pathname.c_str(),
  		(char *)g->home_directory.c_str(),
  		(char *)"RESTART",
		(char *)"SCAN_ALL",
		(char *)"-e0",
		(char *)"-ni",
  		(char *)NULL
  		};

//  cout << "Gclamp::callback_restart_as_root - pathname= " << g->gclamp_pathname << endl;
//  cout << "Gclamp::callback_restart_as_root - directory= " << g->home_directory << endl;

  /* */
  Vtesu vsu(7, array);

//  string command = g->su_command + " \"" + g->gclamp_pathname + " -h " + g->home_directory + " SCAN_ALL &\" &";

//  cout << "Gclamp::callback_scan_all - command= " << command << endl;

//  system(command.c_str());

  if (vsu.parent_quit_flag) exit(EXIT_SUCCESS);  // quick exit...
  return;
  }


pthread_t thread;

gtk_grab_add( g->gclamp_image );

g->start_time = time(NULL);
g->scan_all = TRUE;
g->busy = 1;
g->summary.clear();
gtk_label_set_label(GTK_LABEL(g->summary_label), "");
gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &black);

if ( pthread_create(
                   &thread,
                   NULL,
                   (void *(*)(void *))do_scan,
                   (void *)g
                   ) )
  {
  cerr << "New thread for scan failed" << endl;
  gtk_label_set_label(GTK_LABEL(g->summary_label), "New thread for scan failed");
  g->busy = 0;
  }
else
  {
  g->start_timer(g);
  }
}







// THE VIEW MENU ---------------------------------------------------------

void Gclamp::callback_view_freshclam_log(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_view_freshclam_log" << endl;
if (!g->view_freshclam_log)
  {
  g->view_freshclam_log = new View(g, "freshclam.log", g->file_contents_to_string("/var/log/freshclam.log"));
  }
}

void Gclamp::callback_view_gclamp_log(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_view_gclamp_log" << endl;
if (!g->view_gclamp_log)
  {
  string logname = g->home_directory + "/gclamp.log";

  g->view_gclamp_log = new View(g, "gclamp.log", g->file_contents_to_string(logname));
  }
}


void Gclamp::callback_view_gclamp_defaults(GtkWidget *widget, Gclamp *g)
{
cout << "Gclamp::callback_view_gclamp_defaults" << endl;
if (!g->view_gclamp_defaults)
  {
  string fname = g->home_directory + "/gclamp.defaults";
  g->view_gclamp_defaults = new View(g, "gclamp.defaults", g->file_contents_to_string(fname));
  }
}


// -----------------------------------------------------------------------







// Check against the list of running processes - the full pathname as invoked
// Get it to return the pid, use ps -eo pid -eo %a --no-headers
bool Gclamp::is_running(string command, int &pid, Gclamp *g)
{
int p;
char *c = (char *)( g->get_file( (char *)"ps -eo pid -eo \"%a\" --no-headers" ) ).c_str();

while (*c)
  {
  p = strtol(c, &c, 0);
  while (isblank(*c)) c++;

  if (strncmp(command.c_str(), c, command.length())==0)
    {
//    cout << "Gclamp::is_running - pid= " << pid << " : command = " << command << endl;
    pid = p;
    return TRUE;
    }

  while (*c && *c !='\n') c++;  // move to next entry
  while (*c == '\n') c++;
  }
return FALSE;
}

/***
bool Gclamp::have_su_command(string &msg, Gclamp *g)
{
static string prefix[] =
  {
  "/usr/bin/",
  "/usr/sbin/",
  "/bin/",
  "/sbin/",
  "/usr/local/bin/",
  "/usr/local/sbin/",
  ""
  };

string command;
string pathname;
struct stat64 statbuf;

if (g->su_command.empty())
  {
  msg = "User hasn't chosen a graphical su";
  return FALSE;
  }
    
command = (g->su_command=="kdesu -n") ? "kdesu" : g->su_command;

for (int n=0; !prefix[n].empty(); ++n)
  {
  string pathname = prefix[n] + command;
  if (!(stat64(pathname.c_str(), &statbuf)))
    {
    msg = pathname;
    return TRUE;
    }
  }

msg = command + " is not installed";
return FALSE;
}
***/







// To be called as a thread
int Gclamp::do_update(void *gclamp)
{
Gclamp *g = (Gclamp *)gclamp;
int rc;

//string command = g->su_command + " " + g->update_pathname;

//cout << "Gclamp::do_update : command= " << command << endl;

//if (rc = system(command.c_str()))  // we assume it works
//  {
//  cerr << "Gclamp::do_update : new_process FAILED : rc= " << rc << endl;
  
//

//cout << "Gclamp::do_update - g->su_command= " << g->su_command << endl;

rc = system(g->update_pathname.c_str());


// gtk_init(0, NULL); // doesn't work

//char *array[4] =
//		{
//		(char *)g->update_pathname.c_str(),
//		(char *)g->su_command.c_str(),
//		(char *)"-ni",
//		(char *)NULL
//		};


//Vtesu vsu(3, array);

//  string command = g->su_command + " \"" + g->gclamp_pathname + " -h " + g->home_directory + " SCAN_ALL &\" &";

//  cout << "Gclamp::callback_scan_all - command= " << command << endl;

//  system(command.c_str());

//if (vsu.parent_quit_flag) exit(EXIT_SUCCESS);  // quick exit...

return 0;
}


// The problem here is that we don't get any feedback
// Actually we get feedback to the xterm window which eventually self-closes
// when then datbase has been downloaded. (if we use xtermsu)
void Gclamp::callback_update_db(GtkWidget *widget, Gclamp *g)
{
string msg;
bool done = FALSE;
int rc;
pid_t pid;
  
if (g->busy) return;


// Start up gclamp_update

// Open named pipe
int fd;
int len;
char buffer[PIPE_BUF];

*buffer = 0;

if (g->busy) return;

gtk_label_set_label(GTK_LABEL(g->summary_label), "");
gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &black);
 
g->data_scanned = g->data_read = g->num_scanned = g->num_denied = g->num_infected = 0;
gtk_label_set_label(GTK_LABEL(g->scanned_label), "0");
gtk_label_set_label(GTK_LABEL(g->infected_label), "0");
gtk_label_set_label(GTK_LABEL(g->current_file_label), "");
gtk_label_set_label(GTK_LABEL(g->warning_label), "");

gtk_widget_modify_fg(GTK_WIDGET(g->infected_label), GTK_STATE_NORMAL, &black);

/***
if (!g->have_su_command(msg, g))
  {  
  gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
  gtk_label_set_label(GTK_LABEL(g->status_label), msg.c_str());
  g->fix_db_status(TRUE, g);
  return;
  }
***/

unlink(fifo_name.c_str());
//sleep(1);
if ( ((mkfifo(fifo_name.c_str(), 0666)) < 0) && (errno != EEXIST) )
  {
  // ERROR
  msg = "mkfifo FAILED: ";
  msg += strerror(errno);

//  cout << "Gclamp::callback_update_db : "<< msg << endl;
    
  gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
  gtk_label_set_label(GTK_LABEL(g->status_label), msg.c_str());
  g->fix_db_status(TRUE, g);
  return;
 }

//cout << "Gclamp::callback_update_db : created fifo" << endl;

if ( (fd = open(fifo_name.c_str(), O_RDONLY | O_NONBLOCK)) < 0)
  {
  // ERROR
//  cout << "Gclamp::callback_update_db : open fifo FAILED" << strerror(errno) << endl;
  gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
  gtk_label_set_label(GTK_LABEL(g->status_label), "Can't open fifo");
  g->fix_db_status(TRUE, g);
  unlink("gclamp");
  return;


  }

//cout << "Gclamp::callback_update_db : opened fifo" << endl;

gtk_grab_add( g->gclamp_image );

gtk_label_set_label(GTK_LABEL(g->status_label), "Executing UPDATE");
gtk_main_iteration_do(FALSE); // This runs a single iteration of the main loop

pthread_t thread;
g->start_time = time(NULL);

g->busy = TRUE;
g->summary.clear();
gtk_label_set_label(GTK_LABEL(g->summary_label), "");
gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &black);

// We really want this to return immediately, NOT when it terminates!
// Perhaps use a thread...

if ( pthread_create(
                   &thread,
                   NULL,
                   (void *(*)(void *))do_update,
                   (void *)g
                   ) )

// Change this to new_process later...

//cout << "Gclamp::callback_update_db 1: g->update_pathname= \"" << g->update_pathname << "\"" << endl;

//if (system(g->update_pathname.c_str()) != 0)
  {
  cerr << "New thread for update failed" << endl;

  gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
  gtk_label_set_label(GTK_LABEL(g->status_label), "Update: New thread failed");
  g->fix_db_status(TRUE, g);
  g->busy = FALSE;
  return;
  }
else
  {
  g->start_timer(g);
  }



string command = g->su_command + " " + g->update_pathname;
  

  
//cout << "Gclamp::callback_update_db : Executing UPDATE - command= " << command << endl;

sleep(1);
  
  


if (g->is_running(command, pid, g))
  {
//  cout << "Gclamp::callback_update_db : " << command << " IS RUNNING" << endl;

  // We need it to time out here
  while  (!g->is_running(g->update_pathname, pid, g))
    {
//    cout << update_pathname << " NOT RUNNING " << n++ << endl;

//    cout << "Gclamp::callback_update_db : " << update_pathname  << " IS RUNNING" << endl;
    if (!g->is_running(command, pid, g))
      {
//      cout << "Gclamp::callback_update_db : update aborted by user" << endl;

      gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
      gtk_label_set_label(GTK_LABEL(g->status_label), "Update: aborted by user");
      g->fix_db_status(TRUE, g);        
      close(fd);
      unlink(fifo_name.c_str());  
      g->busy = FALSE;

      return;
      }

/*
    if ( (time(NULL) - g->start_time) >= g->su_timeout )
      {
      cout << "Gclamp::callback_update_db : su timed out" << endl;
      gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
      gtk_label_set_label(GTK_LABEL(g->status_label), "Update: su timed out");
      g->fix_db_status(TRUE, g);
      close(fd);
      unlink(fifo_name.c_str());
  
      g->busy = FALSE;

      // Kill kdesu, xtermsu or gksu
      // We can kill kdesu and gksu OK; xtermsu may be more tricky
      kill(pid, SIGTERM);
      if (g->su_command == "xtermsu")
        {
        string command = "su root -c " + g->update_pathname;
        if (g->is_running(command, pid, g))
          {
          kill(pid, SIGTERM);
          }
        }
      return;
      }
*/
    gtk_main_iteration_do(FALSE); // This runs a single iteration of the main loop
    usleep(500);
    }
  }

// g->update_pathname is empty here!
//cout << "Gclamp::callback_update_db 2: \"" << g->update_pathname << "\" IS RUNNING" << endl;



while  (g->is_running(g->update_pathname, pid, g))
  {
  if ( (len = read(fd, buffer, PIPE_BUF-1)) > 0)
    {
    string msg;

//    cout << "Gclamp::callback_update_db : read= " << buffer << endl;

    if (strstr(buffer, "Failure:"))
      {
      gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
      gtk_label_set_label(GTK_LABEL(g->status_label), buffer);
      g->fix_db_status(TRUE, g);        
      break;
      }
      
    else
      {
      gtk_label_set_label(GTK_LABEL(g->status_label), buffer);
      g->fix_db_status(FALSE, g);
      break;
      }

    }
  else if ((len < 0) && (errno != EAGAIN))
    {
//    cout << "Gclamp::callback_update_db : read error #" << errno << " : " << strerror(errno) << endl;
    }
  gtk_main_iteration_do(FALSE); // This runs a single iteration of the main loop
  usleep(500);
  }

if (!*buffer)
  {
  // We got nothing from gclamp_update
  gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
  gtk_label_set_label(GTK_LABEL(g->status_label), "Nothing came from gclamp_update!");
  g->fix_db_status(TRUE, g); 
  }

close(fd);
unlink(fifo_name.c_str());


g->busy = FALSE;

return;
}

string Gclamp::file_contents_to_string(string pathname)
{
fstream ifp;
string contents;
ifp.open(pathname.c_str(), ios::in  | ios::binary );
if (ifp.is_open())
  {
  char c;
  while (ifp.get(c))
    {
    contents += c;
    }
  ifp.close();
  }
else cerr << "Gclamp::file_contents_to_string - can't open " << pathname << endl;
return contents;
}



string Gclamp::get_db_date(Gclamp *g)
{
string date;
char *d;
char *version = (char *)(g->get_file("freshclam -V")).c_str();
if (version)
  {
  if ( (d=strstr(version, "/")) )
    {
    d++;
    if ( (d=strstr(d, "/")) )
      {
      d++;
      date = d;

      // remove terminal newline
      if ( (date[date.length()-1] == '\n') )
        {
        date.resize(date.length()-1);
        }    
      }
    }
  }
return date;
}

int Gclamp::get_db_days(Gclamp *g)
{
char *d, *p;
time_t t_now = time(NULL);
time_t t_then;
struct tm then;
int m, seconds;

string date = g->get_db_date(g);

if (date.empty()) return -1;

p = d = (char *)date.c_str();

while(!isblank(*p)) p++; // Skip weekday
while(isblank(*p)) p++;  // Skip blanks
    
for (m=0; m<12; ++m)
  {
  if (strncasecmp( (month_names[m]).c_str(), p, 3)==0) break; 
  }
if (m<12) then.tm_mon = m;               // MONTH
else return -1;

while( (*p) && (!isblank(*p)) ) p++; // Skip month
while(isblank(*p)) p++;  // Skip blanks
    
then.tm_mday = atoi(p);          // DAY
    
//cout << "Day " << then.tm_mday << endl;

while( (*p) && (!isblank(*p)) ) p++; // Skip day
while(isblank(*p)) p++;  // Skip blanks

then.tm_hour = atoi(p);          // HOUR
    
//cout << "Hour " << then.tm_hour << endl;

while ((*p) && ((*p)!=':')) p++;
if (*p) p++;

then.tm_min = atoi(p);        // MINUTE
    
//cout << "Minute " << then.tm_min << endl;
 
while ((*p) && ((*p)!=':')) p++;
if (*p) p++;

then.tm_sec = atoi(p);           // SECOND
    
//cout << "Second " << then.tm_sec << endl;
  
while( (*p) && (!isblank(*p)) ) p++; // Skip second
while(isblank(*p)) p++;  // Skip blanks

then.tm_year = atoi(p) - 1900;   // YEAR
    
//cout << "Year " << then.tm_year << endl;

then.tm_isdst = 0;               // IGNORE daylight saving
 
// Other values ignored by mktime

t_then = (time_t)mktime(&then);

seconds = t_now - t_then;

// time difference in seconds divided by seconds per day
return (t_now - t_then) / (24*60*60);
}


gboolean Gclamp::check_database(gpointer gdata)
{
//cout << "Gclamp::check_database" << endl;
Gclamp *g = (Gclamp *)gdata;

int days = g->get_db_days(g);

if (days < 0)
  {
  // ERROR - NO DATABASE! 
  gtk_label_set_text(GTK_LABEL(g->db_status_label), "ERROR: No database?");
  gtk_widget_modify_fg(GTK_WIDGET(g->db_status_label), GTK_STATE_NORMAL, &red);
  g->summary = freshclam_log_warning;
  gtk_label_set_label(GTK_LABEL(g->summary_label), g->summary.c_str());
  gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &red);
  }
else
  {
  if (g->update_days && (days >= g->update_days))
    {
    g->callback_update_db(NULL, g);
    }
  else if (days >= g->warn_days) 
    {
    string msg = "WARNING: DB date " + g->get_db_date(g);
    gtk_label_set_text(GTK_LABEL(g->db_status_label), msg.c_str());
    gtk_widget_modify_fg(GTK_WIDGET(g->db_status_label), GTK_STATE_NORMAL, &red);
    }
  else
    {
    string date = "Database date: " + g->get_db_date(g);
    gtk_label_set_text(GTK_LABEL(g->db_status_label), date.c_str());
    gtk_widget_modify_fg(GTK_WIDGET(g->db_status_label), GTK_STATE_NORMAL, &black);
    }
  }
return TRUE;
}



void Gclamp::callback_restart_as_root(GtkWidget *widget, Gclamp *g)
{
string msg;

// Check for graphical su first!
gtk_label_set_label(GTK_LABEL(g->summary_label), "");
gtk_widget_modify_fg(GTK_WIDGET(g->summary_label), GTK_STATE_NORMAL, &black);
 
g->data_scanned = g->data_read = g->num_scanned = g->num_denied = g->num_infected = 0;
gtk_label_set_label(GTK_LABEL(g->scanned_label), "0");
gtk_label_set_label(GTK_LABEL(g->infected_label), "0");
gtk_label_set_label(GTK_LABEL(g->current_file_label), "");
gtk_label_set_label(GTK_LABEL(g->warning_label), "");

gtk_widget_modify_fg(GTK_WIDGET(g->infected_label), GTK_STATE_NORMAL, &black);

/***
if (!g->have_su_command(msg, g))
  {  
  gtk_label_set_label(GTK_LABEL(g->warning_label), "NOT UPDATED");
  gtk_label_set_label(GTK_LABEL(g->status_label), msg.c_str());
  g->fix_db_status(TRUE, g);        
  return;
  }
***/

char *array[7] = // { NULL };
		/* */
		{
		(char *)g->gclamp_pathname.c_str(),
		(char *)g->home_directory.c_str(),
		(char *)"RESTART",
		(char *)g->su_command.c_str(),
		(char *)"-ni",
		(char *)NULL
		};


//cout << "Gclamp::callback_restart_as_root - pathname= " << g->gclamp_pathname << endl;
//cout << "Gclamp::callback_restart_as_root - directory= " << g->home_directory << endl;

Vtesu vsu(6, array);

//cout << "Gclamp::callback_restart_as_root - got here" << endl;
sleep(1);

if (vsu.parent_quit_flag)	exit(EXIT_SUCCESS);  // quick exit...
}

// Fix program defaults
void Gclamp::clear_info(Gclamp *g)
{
g->directories.clear();
g->directories_omit.clear();
g->files.clear();
g->files_omit.clear();
g->infected_action = action(LEAVE);
g->su_command.clear();
g->want_log = g->append_log = g->update_days = g->log_empty_files = g->log_OK_files = g->log_excluded_files = 0;

}

void Gclamp::get_info_from_widgets(Gclamp *g)
{
// Clear
g->clear_info(g);

  // Get the info
g->want_log = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->log_checkbutton));
g->append_log = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->log_append_checkbutton));
g->log_empty_files = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->log_include_empty_checkbutton));
g->log_OK_files = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->log_include_OK_checkbutton));
g->log_excluded_files = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->log_include_excluded_checkbutton));

if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->susudo_checkbutton)))
  {
  su_command = "-e0";
  }
else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->su_checkbutton)))
  {
  su_command = "-e1";
  }
else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->sudo_checkbutton)))
  {
  su_command = "-e2";
  }


if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->ignore_checkbutton)))
  {
  infected_action = action(LEAVE);
  }
else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->move_checkbutton)))
  {
  infected_action = action(MOVE);
  }
else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->copy_checkbutton)))
  {
  infected_action = action(COPY);
  }
else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->delete_checkbutton)))
  {
  infected_action = action(DELETE);
  }

g->browser_command = gtk_entry_get_text(GTK_ENTRY(g->browser_entry)); // maybe remove redundant white space

g->warn_days = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(g->db_warn_spinner));
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->auto_update_checkbutton)))
  {
  g->update_days = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(g->auto_update_spinner));
  }
else g->update_days = 0;

frd->get_request_d_pathname_multiple(directories);
frd_omit->get_request_d_pathname_multiple(directories_omit);
frf->get_request_f_pathname_multiple(files);
frf_omit->get_request_f_pathname_multiple(files_omit);

list<string>::iterator d;
for (d=directories_omit.begin(); d!=directories_omit.end(); ++d)
  {
  if ( (*d)[d->length()-1] != '/' ) *d += '/';
  }
}

string Gclamp::dtos(double n)
{
ostringstream ost;
ost << n;
return ost.str();
}


string Gclamp::itos(int n)
{
ostringstream ost;
ost << n;
return ost.str();
}



void Gclamp::callback_save_defaults(GtkWidget *widget, Gclamp *g)
{
string buffer;
fstream ofp;
string fname = g->home_directory + "/gclamp.defaults";
  
//cout << "Gclamp::callback_save_defaults" << endl;
  
g->get_info_from_widgets(g);

ofp.open(fname.c_str(), ios::out | ios::binary | ios::trunc );
if ( ofp.is_open() )
  {
  buffer = "# Defaults file \"" +  fname + "\"\n\n";
  
  buffer += Want_Log_TXT + "          " + ((g->want_log) ? " = 1\n" : " = 0\n");
  buffer += Append_Log_TXT + "        " + ((g->append_log) ? " = 1\n" : " = 0\n");
  buffer += Log_Empty_Files_TXT + "   " + ((g->log_empty_files) ? " = 1\n" : " = 0\n");
  buffer += Log_OK_Files_TXT  + "      " + ((g->log_OK_files) ? " = 1\n" : " = 0\n");
  buffer += Log_Excluded_Files_TXT + ((g->log_excluded_files) ? " = 1\n" : " = 0\n");
    

  buffer += Use_Su_TXT +  "             = ";
  buffer += g->su_command + "\n";

  buffer += Warn_Days_TXT + "          = " + g->itos(g->warn_days)  + "\n";
  buffer += Auto_Update_Days_TXT + "        = " + g->itos(g->update_days)  + "\n";

  buffer += Action_TXT + "             = " + g->itos(g->infected_action) + "\n";

  buffer += Browser_Command_TXT + "    = " + g->browser_command + "\n";

  if (!g->directories.empty())
    {
    list<Directory>::iterator d;
    buffer += Start_Directories_TXT + "\n";
    for (d=g->directories.begin(); d!=g->directories.end(); ++d)
      {
      if ((*d).recursive) buffer += "    R";
      else buffer += "    NR";
      buffer += "    " + (*d).name + "\n";
      }
    buffer += End_Directories_TXT + "\n";
    }
  if (!g->directories_omit.empty())
    {
    list<string>::iterator i;
    buffer += Start_Directories_Omit_TXT + "\n";
    for (i=g->directories_omit.begin(); i!=g->directories_omit.end(); ++i)
      {
      buffer += "    " + (*i) + "\n";
      }
    buffer += End_Directories_Omit_TXT + "\n";
    }
  if (!g->files.empty())
    {
    list<string>::iterator i;
    buffer += Start_Files_TXT + "\n";
    for (i=g->files.begin(); i!=g->files.end(); ++i)
      {
      buffer += "    " + (*i) + "\n";
      }
    buffer += End_Files_TXT + "\n";
    }

  if (!g->files_omit.empty())gtk_main_iteration_do(FALSE); // This runs a single iteration of the main loop
    {
    list<string>::iterator i;
    buffer += Start_Files_Omit_TXT + "\n";
    for (i=g->files_omit.begin(); i!=g->files_omit.end(); ++i)
      {
      buffer += "    " + (*i) + "\n";
      }
    buffer += End_Files_Omit_TXT + "\n";
    }


  ofp.write( buffer.c_str(), buffer.length() );
  ofp.close();
  chmod(fname.c_str(), 0677); // make sure it is read/write by everyone
  }
}

void Gclamp::getright(string &s, string &v)
{
unsigned int p=0;
bool inquote = FALSE;

v = "";  // start with an empty string!

while ( (p < s.length()) && isblank(s[p]) )
  {
  p++;
  }

if ( (p < s.length()) && ((s[p]=='=') || (s[p]==':')) )
  {
  p++;
  while ( (p < s.length()) && isblank(s[p]) )
    {
    p++;
    }
  }

while (p < s.length())
  {
  if (s[p] == '\"')
    {
    inquote = !inquote;
    p++;
    continue;
    }

  // If any of these the rest of the line is ignored unless in quote
  // Horizontal white space has to be allowed
  if ( (!inquote) &&
    ((s[p]=='#') || (s[p]==';') || (s[p]=='\n')) ) break;

    v += s[p];
    p++;
  }
}

bool Gclamp::isseparator(char x)
{
return ((x == ' ')||(x == '\t')||(x == '=')||(x == ':'));
}

bool Gclamp::getvalue(string &line, string &name, string &value)
{
if ( (strncmp(name.c_str(), line.c_str(), name.length())==0) &&
    isseparator(line[name.length()]) )
  {
  string s;
  string r;
  s = line.substr(name.length());
  getright(s, r);
  remove_leading(r);  
  remove_trailing(r);
  value = r;
  return TRUE;
  }
return FALSE;
}

bool Gclamp::getvalue(fstream &ifp,
                      string &line,
                      string &startname,
                      string &endname,
                      list<string> &value)
{
    
if (line == startname)
  {
  while (getline(ifp, line, TRUE))
    {
    if (line == endname)
      {
      return TRUE;
      }
    if (line.empty()) line = "\n";  // Allow for empty lines esp. in private copy of changelog
    value.push_back(line);
    }
  }
return FALSE;
}

void Gclamp::remove_trailing(string &s)
{
if ( (s.length() > 0) && (s[s.length()-1] == '\n') )
  {
  s.resize(s.length()-1);
  }
while (s.length() > 0)
  {
  if ( (s[s.length()-1] == ' ') || (s[s.length()-1]== '\t') )
    {
    s.resize(s.length()-1);
    }
  else break;
  }
}

void Gclamp::remove_leading(string &s)
{
while (s.length() > 0)
    {
    if ( (s[0] == ' ') || (s[0] == '\t') )
        {
        s = s.substr(1);
        }
    else break;
    }
}

bool Gclamp::getline(fstream &ifp, string &line, bool clear_leadin)
{
char c;

if (ifp.eof()) return FALSE;

line = "";
while ( !ifp.eof() )
  {
  ifp.get(c);
  if ((c == 0x0a) || (c == 0) || (ifp.eof() )) break;
  line += c;
  }
if (clear_leadin) remove_leading(line);
remove_trailing(line);
return TRUE;
}

void Gclamp::callback_load_defaults(GtkWidget *widget, Gclamp *g)
{
fstream ifp;
string fname = g->home_directory + "/gclamp.defaults";

//cout << "Gclamp::callback_load_defaults" << endl;

g->clear_info(g);

ifp.open(fname.c_str(), ios::in | ios::binary );
if ( ifp.is_open() )
  {
  string line;
  string value;

  while ( g->getline(ifp, line, TRUE) )
    {
    if (g->getvalue(line, Want_Log_TXT, value))
      {
      if (value=="1") g->want_log = 1;
      else g->want_log = 0;
      }
    else if (g->getvalue(line, Append_Log_TXT, value))
      {
      if (value=="1") g->append_log = 1;
      else g->append_log = 0;
      }
    else if (g->getvalue(line, Log_Empty_Files_TXT, value))
      {
      if (value=="1") g->log_empty_files = 1;
      else g->log_empty_files = 0;
      }
    else if (g->getvalue(line, Log_OK_Files_TXT, value))
      {
      if (value=="1") g->log_OK_files = 1;
      else g->log_OK_files = 0;
      }
    else if (g->getvalue(line, Log_Excluded_Files_TXT, value))
      {
      if (value=="1") g->log_excluded_files = 1;
      else g->log_excluded_files = 0;
      }
    else if (g->getvalue(line, Browser_Command_TXT, value))
      {
      g->browser_command = value;
      }   
    else if (g->getvalue(line, Use_Su_TXT, value))
      {
      if ((value=="-e0") || (value=="-e1") || (value=="-e2"))
        {
        g->su_command = value;
        }
      }
    else if (g->getvalue(line, Warn_Days_TXT, value))
      {
      g->warn_days = atoi(value.c_str());
      }
    else if (g->getvalue(line, Auto_Update_Days_TXT, value))
      {
      g->update_days = atoi(value.c_str());
      }  
    else if (g->getvalue(line, Action_TXT, value))
      {
      g->infected_action = (action)atoi(value.c_str());
      }
    else if (line==Start_Directories_TXT)
      {
      while ( g->getline(ifp, line, TRUE) )
        {
        if (line==End_Directories_TXT) break;
        Directory d;
        if ( (strncmp("R", line.c_str(), 1)==0) && g->isseparator(line[1]) )
          {
          d.recursive = 1;
          line = line.substr(1);           
          }
        else
          {
          d.recursive = 0; 
          while ( (!line.empty()) && (!g->isseparator(line[0])) ) 
            {
            line = line.substr(1);
            }
          }
        g->remove_leading(line);
        d.name = line;
        g->directories.push_back(d);
        }
      continue;
      }
    else if (g->getvalue(ifp, line, Start_Directories_Omit_TXT, End_Directories_Omit_TXT, g->directories_omit))
      {
      continue;
      }
    else if (g->getvalue(ifp, line, Start_Files_TXT, End_Files_TXT, g->files))
      {
     continue;
      }
    else if (g->getvalue(ifp, line, Start_Files_Omit_TXT, End_Files_Omit_TXT, g->files_omit))
      {
      continue;
      }
    }
  ifp.close();

  if (g->su_command.empty())
    {
    g->su_command = "-e0"; // default
    }
  }
  
else  // DEFAULTS
  {

  // No defaults file...
  // Set program defaults ... files to be scanned to home directory etc.
  Directory d;
 
  g->want_log = 1;
  g->infected_action = action(MOVE);

  d.recursive = 1;
  d.name = getenv("HOME");    // home directory
  g->directories.push_back(d);
    
  g->su_command == "-e0";

  }




// These values need to be inserted into the GUI

if (widget) // If called from the LOAD button
  {
  list<Directory>::iterator d;
  list<string>::iterator i;

  // Directories
  //============
 
  // Clear window 2
  g->frd->clear_window2(g->frd);

  // Append directories
  for (d=g->directories.begin(); d!=g->directories.end(); ++d)
    {
    g->frd->append_treeview2( (gchar *)(*d).name.c_str(), (*d).recursive, g->frd);
    }

  // Omit directories
  // Clear window 2
  g->frd_omit->clear_window2(g->frd_omit);
  for (i=g->directories_omit.begin(); i!=g->directories_omit.end(); ++i)
    {
    g->frd_omit->append_treeview2( (gchar *)(*i).c_str(), FALSE, g->frd_omit);
    }

//======
// Files
//======
    
  // Clear window 2
  g->frf->clear_window2(g->frf);

  // Append files
  for (i=g->files.begin(); i!=g->files.end(); ++i)
    {
    g->frf->append_treeview2( (gchar *)(*i).c_str(), FALSE, g->frf);
    }

//===========
// OMIT Files
//===========
    
  // Clear window 2
  g->frf_omit->clear_window2(g->frf_omit);

  // Append files
  for (i=g->files_omit.begin(); i!=g->files_omit.end(); ++i)
    {
    g->frf_omit->append_treeview2( (gchar *)(*i).c_str(), FALSE, g->frf_omit);
    }


  // Miscellaneous
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_checkbutton), g->want_log);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_append_checkbutton), g->append_log);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_overwrite_checkbutton), !(g->append_log) );
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_include_empty_checkbutton), g->log_empty_files);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_include_OK_checkbutton), g->log_OK_files);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_include_excluded_checkbutton), g->log_excluded_files);

  gtk_widget_set_sensitive(g->log_overwrite_checkbutton,g->want_log);
  gtk_widget_set_sensitive(g->log_append_checkbutton,g->want_log);
  gtk_widget_set_sensitive(g->log_include_empty_checkbutton,g->want_log);
  gtk_widget_set_sensitive(g->log_include_OK_checkbutton,g->want_log);
  gtk_widget_set_sensitive(g->log_include_excluded_checkbutton,g->want_log);

  if (g->browser_command.length())
    {
    gtk_entry_set_text(GTK_ENTRY(g->browser_entry), g->browser_command.c_str());
    }
  else
    {
    gtk_entry_set_text(GTK_ENTRY(g->browser_entry), "firefox"); // default
    }

  if (g->infected_action == action(LEAVE))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->ignore_checkbutton), TRUE);
    g->callback_ignore_checkbutton_clicked(widget, g);
    }
  else if (g->infected_action == action(MOVE))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->move_checkbutton), TRUE);
    g->callback_move_checkbutton_clicked(widget, g);
    }
  else if (g->infected_action == action(COPY))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->copy_checkbutton), TRUE);
    g->callback_copy_checkbutton_clicked(widget, g);
    }
  else if (g->infected_action == action(DELETE))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->delete_checkbutton), TRUE);
    g->callback_delete_checkbutton_clicked(widget, g);
    }


  if (g->su_command == "-e0")
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->susudo_checkbutton), TRUE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->su_checkbutton), FALSE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->sudo_checkbutton), FALSE);
    }
  else if (g->su_command == "-e1")
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->susudo_checkbutton), FALSE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->su_checkbutton), TRUE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->sudo_checkbutton), FALSE);
    }
  else if (g->su_command == "-e2")
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->susudo_checkbutton), FALSE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->su_checkbutton), FALSE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->sudo_checkbutton), TRUE);
    }
  
  if (g->warn_days>0)
    {
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(g->db_warn_spinner), g->warn_days);
    }
  else gtk_spin_button_set_value(GTK_SPIN_BUTTON(g->db_warn_spinner), 1);

  if (g->update_days>0)
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->auto_update_checkbutton), TRUE);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(g->auto_update_spinner), g->update_days);
    gtk_widget_set_sensitive(g->auto_update_spinner, TRUE);
    }
  else
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->auto_update_checkbutton), FALSE);
    gtk_widget_set_sensitive(g->auto_update_spinner, FALSE);
    }
  }
}

void Gclamp::callback_log_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_log_checkbutton_clicked" << endl;
if (g->log_checkbutton && g->log_append_checkbutton && g->log_overwrite_checkbutton)
  {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->log_checkbutton)))
    {
    gtk_widget_set_sensitive(g->log_append_checkbutton, TRUE);
    gtk_widget_set_sensitive(g->log_overwrite_checkbutton, TRUE);
    gtk_widget_set_sensitive(g->log_include_empty_checkbutton, TRUE);
    gtk_widget_set_sensitive(g->log_include_OK_checkbutton, TRUE);
    gtk_widget_set_sensitive(g->log_include_excluded_checkbutton, TRUE);
    }
  else
    {
    gtk_widget_set_sensitive(g->log_append_checkbutton, FALSE);
    gtk_widget_set_sensitive(g->log_overwrite_checkbutton, FALSE);
    gtk_widget_set_sensitive(g->log_include_empty_checkbutton, FALSE);
    gtk_widget_set_sensitive(g->log_include_OK_checkbutton, FALSE);
    gtk_widget_set_sensitive(g->log_include_excluded_checkbutton, FALSE);
    }
  }
}

void Gclamp::callback_log_group_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
if (g->log_append_checkbutton && g->log_overwrite_checkbutton)
  {
  if (widget==g->log_append_checkbutton)
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_overwrite_checkbutton),
        (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget))));
    }
  else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->log_append_checkbutton),
      (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget))));
  }
}

void Gclamp::callback_move_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_move_checkbutton_clicked" << endl;

if (g->move_checkbutton && g->copy_checkbutton && g->delete_checkbutton && g->ignore_checkbutton)
  {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->move_checkbutton)))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->copy_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->delete_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->ignore_checkbutton), FALSE);  
    }
  }
}

void Gclamp::callback_copy_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_copy_checkbutton_clicked" << endl;
if (g->move_checkbutton && g->copy_checkbutton && g->delete_checkbutton && g->ignore_checkbutton)
  {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->copy_checkbutton)))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->move_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->delete_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->ignore_checkbutton), FALSE);  
    }
  }
}

void Gclamp::callback_delete_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_delete_checkbutton_clicked" << endl;
if (g->move_checkbutton && g->copy_checkbutton && g->delete_checkbutton && g->ignore_checkbutton)
  {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->delete_checkbutton)))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->move_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->copy_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->ignore_checkbutton), FALSE);  
    }
  }
}

void Gclamp::callback_ignore_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_ignore_checkbutton_clicked" << endl;
if (g->move_checkbutton && g->copy_checkbutton && g->delete_checkbutton && g->ignore_checkbutton)
  {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->ignore_checkbutton)))
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->move_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->copy_checkbutton), FALSE);  
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->delete_checkbutton), FALSE);  
    }
  }
}

void Gclamp::callback_su_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
//cout << "Gclamp::callback_su_checkbutton_clicked" << endl;
if (g->susudo_checkbutton && g->su_checkbutton && g->sudo_checkbutton)
  {
  if ( (widget==g->susudo_checkbutton) &&
      gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) )
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->su_checkbutton), FALSE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->sudo_checkbutton), FALSE);
    }
  else if ( (widget==g->su_checkbutton) &&
      gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) )
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->susudo_checkbutton), FALSE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->sudo_checkbutton), FALSE);
    }
  else if ( (widget==g->sudo_checkbutton) &&
      gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) )
    {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->susudo_checkbutton), FALSE);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(g->su_checkbutton), FALSE);
    }
  }
}

void Gclamp::callback_auto_update_checkbutton_clicked(GtkWidget *widget, Gclamp *g)
{
if (g->auto_update_checkbutton && g->auto_update_spinner)
  {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(g->auto_update_checkbutton)))
    {
    gtk_widget_set_sensitive(GTK_WIDGET(g->auto_update_spinner), TRUE);  
    }
  else gtk_widget_set_sensitive(GTK_WIDGET(g->auto_update_spinner), FALSE); 
  }
}




// Create a spinner (integer values)
GtkWidget *Gclamp::create_spinner(int s_start, int s_min,  int s_max)
{
GtkAdjustment *spinner_adj;

spinner_adj = (GtkAdjustment *) gtk_adjustment_new (s_start, s_min, s_max, 1.0, 0.0, 0.0);

// creates the spinner, with no decimal places
return( gtk_spin_button_new (spinner_adj, 1.0, 0) );
}


Gclamp::~Gclamp(void)
{
if (icon_pixbuf)
  {
  g_object_unref(G_OBJECT(icon_pixbuf));
  icon_pixbuf = NULL;
  }
for (int n=0; n<7; ++n)
  {
  if (rw_pixbuf[n])
    {
    g_object_unref(G_OBJECT(rw_pixbuf[n]));
    rw_pixbuf[n] = NULL;
    }
  }
if (blank_pixbuf)
  {
  g_object_unref(G_OBJECT(blank_pixbuf));
  blank_pixbuf = NULL;
  }
}  


// If command is found in the output of "ps ax" twice then already running...
gboolean Gclamp::program_running(char *start_command)
{
char *command = (char *)"ps -eo comm --no-headers";
string buffer = get_file(command);
char *exec_name = &start_command[strlen(start_command) - 1];
char *p;
size_t len;
int n=0;
  
while (exec_name > start_command)
  {
  if ( *(exec_name-1)=='/' )
    {
    break;
    }
  exec_name--;
  }

//cout << "exec_name= " << exec_name << endl;

len = strlen(exec_name);
             
p = (char *)buffer.c_str();

while ( p && (*p) )
  {
  if (strncmp(p, exec_name, len) == 0)
    {
    if ( (*(p+strlen(exec_name))=='\n') || (*(p+strlen(exec_name))==0) )
      {
      if (++n > 1)
        {
        cerr << exec_name << " is already running!" << endl;
        return TRUE;
        }
      }
    }
  while ( (*p) && (*p)!='\n') p++;
  if (*p=='\n') p++;
  }
return FALSE;
}



//void Gclamp::callback_visible(GtkWidget *widget, Gclamp *g)
void Gclamp::callback_visible(Gclamp *g)
{
//gtk_signal_disconnect(GTK_OBJECT(widget), visible_signal);

//cout << "Gclamp::callback_visible - g->do_scan_all= " << g->do_scan_all << endl;
//string msg = "Gclamp::callback_visible - g->do_scan_all= ";
//msg +=  ((g->do_scan_all) ? "1" : "0");

//gtk_label_set_text(GTK_LABEL(status_label), msg.c_str());
gtk_main_iteration_do(FALSE);

if (g->do_scan_all)
  {
//  gtk_label_set_text(GTK_LABEL(status_label, ""))
  if ( (strcmp( (getpwuid( getuid() ))->pw_name , "root" )) ) // if we are not root
    {
    g->do_scan_all = FALSE;
    gtk_label_set_text(GTK_LABEL(g->warning_label), "WHOLE COMPUTER NOT SCANNED");
    gtk_label_set_text(GTK_LABEL(g->status_label), "Not running as root");
    g->fix_db_status(TRUE, g);
    return;
    }

//  msg += " : ABOUT to scan";
//  gtk_label_set_text(GTK_LABEL(status_label), msg.c_str());
//  gtk_main_iteration_do(FALSE);

  callback_scan_all(NULL, g);
  }
return;
}


void Gclamp::decorate_button(GtkWidget *widget, GdkColor *bg_normal,  GdkColor *bg_prelight, const gchar *stock_id)
{
if (bg_normal) gtk_widget_modify_bg(GTK_WIDGET(widget), GTK_STATE_NORMAL, bg_normal);  
if (bg_prelight) gtk_widget_modify_bg(GTK_WIDGET(widget), GTK_STATE_PRELIGHT, bg_prelight);
if ((stock_id) && *(stock_id))
  {
  gtk_button_set_image(GTK_BUTTON(widget), gtk_image_new_from_stock(stock_id, GTK_ICON_SIZE_BUTTON));
  // Make sure the image is displayed!
  gtk_widget_show(GTK_WIDGET(gtk_button_get_image(GTK_BUTTON(widget)))); 
  }
}


Gclamp::Gclamp(int argc, char *argv[])
{
GdkScreen *screen;
GtkWidget *menu;
GtkWidget *menubar;
GtkWidget *menuitem;
GtkWidget *widget, *box;
GtkWidget *notebook;
GtkWidget *table;
gint swidth;
gint sheight;
string msg;
bool restart = FALSE;

// Could make this produce a popup notification that self-destructs
// If coming here from "restart as root" or "complet scan" we don't want to exit.
// Try parsing args first and have one of them as a switch for restart.

//cout << "Gclamp::Gclamp" << endl;

// Parse
if (argc>1)
  {
  for (int n=1; n<argc; ++n)
    {
    if (strcmp(argv[n], "SCAN_ALL")==0)
      {
      do_scan_all = TRUE;
      continue;
      }
    else if (strcmp(argv[n], "RESTART")==0)
    	{
    	restart = TRUE;
        continue;
    	}
    else if (strcmp(argv[n], "-h")==0)
      {
      if (++n < argc)
        {
        home_directory = argv[n];
        continue;
        }
      else
        {
        msg = "arg error - home directory not set with -h\n";
        summary += msg;
        cerr << msg;
        break;
        }
      }
    else
      {
      if (home_directory.empty())
        {
        home_directory = argv[n];
        }
      else
        {
        msg = "arg error - home directory set twice\n";
        summary += msg;
        cerr << msg;         
        break;
        }
      }
    }
  }





if (program_running(argv[0])&& (!restart)) exit(EXIT_FAILURE);

move_checkbutton = copy_checkbutton = delete_checkbutton =
    ignore_checkbutton = susudo_checkbutton = su_checkbutton =
    sudo_checkbutton = log_checkbutton = log_append_checkbutton =
    log_overwrite_checkbutton = auto_update_checkbutton =
    db_warn_spinner = auto_update_spinner = NULL;

accel_group = NULL;

view_freshclam_log = NULL;
view_gclamp_log = NULL;
view_gclamp_defaults = NULL;
view_about = NULL;
busy = timer = world_num = 0;

gclamp_doc_pathname = DATADIR"/gclamp/doc/gclamp.html";

  
gclamp_pathname = BINDIR"/"+ (string)argv[0];

/***
char *realpathname = realpath(argv[0], NULL);


if (realpathname)
  {
  msg =  (string)"BINDIR= " + BINDIR + "\nargv[0]= " + (string)argv[0] + "\nrealpathname = " + realpathname + "\n";
  summary += msg;
  gclamp_pathname = realpathname;
  free(realpathname);
  }
else
  {
  // ERROR
  msg = (string)"Can't get realpath( " + (string)argv[0] + ", NULL )";
  msg += strerror(errno);
  msg += "\n";
  summary += msg;
  cerr << msg;
  }
***/

  
/*****

// Remove this for distribution  ------------------------------------------------
   
if (gclamp_pathname == "/home/david/Projects/gclamp-1.2.0/src/gclamp/gclamp")
  {
  update_pathname = "/home/david/Projects/gclamp-1.2.0/src/gclamp_update/gclamp_update";
  //update_pathname = "/usr/bin/gclamp_update";
  }
else

// ------------------------------------------------------------------------------

*****/

update_pathname = gclamp_pathname + "_update"; // in the same directory



//cout << "Gclamp: - gclamp_pathname    = \"" << gclamp_pathname << "\"" << endl;
//cout << "Gclamp: - update_pathname    = \"" << update_pathname << "\"" << endl;

//msg = "Gclamp: - gclamp_pathname    = \"" + gclamp_pathname + "\"\n" + "Gclamp: - update_pathname    = \"" + update_pathname + "\"\n";
//summary += msg;
//cerr << msg;

  
//cout << "Gclamp: - gclamp_doc_pathname= " << gclamp_doc_pathname << endl;


if (home_directory.empty())
  {
  home_directory = getenv("HOME");
  home_directory += "/gclamp";
  }
quarantine_directory = home_directory + "/quarantine";

//cout << "Gclamp::Gclamp - home_directory = " << home_directory << endl;
//cout << "Gclamp::Gclamp - gclamp_pathname= " << gclamp_pathname << endl;
  
// If it doesn't exist, create it
if (!isdir(home_directory))
  {
  if (mkdir(home_directory.c_str(), 0775))
    {
    msg = "Can't create " + home_directory;
    msg += strerror(errno);
    msg += "\n";
    summary += msg;
    cerr << msg;         
    }
  }

if (!isdir(quarantine_directory))
  {
  if (mkdir(quarantine_directory.c_str(), 0775))
    {
    msg = "Can't create " + quarantine_directory;
    msg += strerror(errno);
    msg += "\n";
    summary += msg;
    cerr << msg;         
    }
//  else cout << "Gclamp::Gclamp - created " << quarantine_directory << endl;
  }
//else cout << "Gclamp::Gclamp - " << quarantine_directory << " already exists" << endl;

gtk_init (&argc, &argv);

window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

gtk_window_set_title(GTK_WINDOW(window), "gclamp");
gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER_ALWAYS);

/*
visible_signal = g_signal_connect (G_OBJECT(window), "window_state_event", //"visibility_event",
  G_CALLBACK (callback_visible),
  this);
*/
/*
visible_signal = g_signal_connect_after (G_OBJECT(window), "expose_event", //"visibility_event",
  G_CALLBACK (callback_visible),
  this);
*/
/*
visible_signal = g_signal_connect (G_OBJECT(window), "expose_event", //"visibility_event",
  G_CALLBACK (callback_visible),
  this);
 */

gtk_init_add(GtkFunction(callback_visible), this);

// --- Set the window icon
icon_pixbuf = gdk_pixbuf_new_from_inline(-1,
					                                icon_pixbuf_src,
					                                FALSE, NULL);

gtk_window_set_icon( GTK_WINDOW(window), icon_pixbuf);


rw_pixbuf[0] = gdk_pixbuf_new_from_inline(-1,
					   rw0_pixbuf_src,
					   FALSE,
					   NULL);
rw_pixbuf[1] = gdk_pixbuf_new_from_inline(-1,
					   rw1_pixbuf_src,
					   FALSE,
					   NULL);
rw_pixbuf[2] = gdk_pixbuf_new_from_inline(-1,
					   rw2_pixbuf_src,
					   FALSE,
					   NULL);
rw_pixbuf[3] = gdk_pixbuf_new_from_inline(-1,
					   rw3_pixbuf_src,
					   FALSE,
					   NULL);
rw_pixbuf[4] = gdk_pixbuf_new_from_inline(-1,
					   rw4_pixbuf_src,
					   FALSE,
					   NULL);
rw_pixbuf[5] = gdk_pixbuf_new_from_inline(-1,
					   rw5_pixbuf_src,
					   FALSE,
					   NULL);
rw_pixbuf[6] = gdk_pixbuf_new_from_inline(-1,
					   rw6_pixbuf_src,
					   FALSE,
					   NULL);

blank_pixbuf = gdk_pixbuf_new_from_inline(-1,
					   blank_pixbuf_src,
					   FALSE,
					   NULL);

screen = gtk_window_get_screen(GTK_WINDOW(window));
swidth = gdk_screen_get_width(screen);
sheight = gdk_screen_get_height(screen);


if (swidth > sheight)
  {
  if (sheight >= 1200)
    {
    width =  2*sheight/3;
    height = 2*sheight/3;    
    }
  else
    {
    width =  swidth/2;    //sheight;   // 9*sheight/10;
    height = 9*sheight/10;    
    }
  }

// UNTESTED: This might not work properly!
else
  {
  if ( (sheight >= 1200)  && ((2*sheight/3) >= swidth) )
    {
    width = 2*sheight/3;
    height = 2*sheight/3;   
    }
  else
    {
    width = swidth;
    height =  2*sheight/3;
    }
  }


gtk_widget_set_size_request (window, width, height);   // width, height

gtk_container_set_border_width(GTK_CONTAINER(window), 0);

g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (callback_quit),
		    NULL);
widget = gtk_vbox_new(FALSE, 0);
gtk_container_add (GTK_CONTAINER (window), widget);
  
tooltips = gtk_tooltips_new();
  
menubar = gtk_menu_bar_new ();

gtk_box_pack_start(GTK_BOX(widget), menubar, FALSE, TRUE, 0);



// FILE

menu = create_bar_submenu(menubar, (char *)"File");


menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Update",
                            accel_group, (char *)"^U", 
  			                    tooltips, (char *)"Update the ClamAV database", 
  			                    GTK_SIGNAL_FUNC(callback_update_db),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Scan",
                            accel_group, (char *)"^S", 
  			                    tooltips, (char *)"Scan selected directories and files", 
  			                    GTK_SIGNAL_FUNC(callback_scan),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Complete scan",
                            accel_group, (char *)"^C", 
  			                    tooltips,
                                (char *)(( (strcmp( (getpwuid( getuid() ))->pw_name , "root" )) )
                                ?
                                "Restart as root and scan whole computer" // if we are not root
                                :
                                "Scan ALL directories and files"),          // if we are root
  			                    GTK_SIGNAL_FUNC(callback_scan_all),
			                      (gpointer)this);

gtk_menu_shell_append(GTK_MENU_SHELL(menu), gtk_separator_menu_item_new());

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Save defaults",
                            accel_group, (char *)"^D", 
  			                    tooltips, (char *)"Save defaults to ~/gclamp/gclamp.defaults", 
  			                    GTK_SIGNAL_FUNC(callback_save_defaults),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Load defaults",
                            accel_group, (char *)"^L", 
  			                    tooltips, (char *)"Load defaults from ~/gclamp/gclamp.defaults", 
  			                    GTK_SIGNAL_FUNC(callback_save_defaults),
			                      (gpointer)this);


gtk_menu_shell_append(GTK_MENU_SHELL(menu), gtk_separator_menu_item_new());


if ( (strcmp( (getpwuid( getuid() ))->pw_name , "root" )) ) // if we are not root
  {
  menuitem = create_menuitem(window,
                            menu, 
  			                    (char *)"Restart as root",
                            accel_group, (char *)"^R", 
  			                    tooltips, (char *)"Restart gclamp as root user", 
  			                    GTK_SIGNAL_FUNC(callback_restart_as_root),
			                      (gpointer)this);
  }

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Quit",
                            accel_group, (char *)"^Q", 
  			                    tooltips, (char *)"Quit gclamp", 
  			                    GTK_SIGNAL_FUNC(callback_quit),
			                      (gpointer)this);



// VIEW

menu = create_bar_submenu(menubar, (char *)"View");
    
menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"View freshclam.log",
                            accel_group, (char *)"^F", 
  			                    tooltips, (char *)"View log file /var/log/freshclam.log", 
  			                    GTK_SIGNAL_FUNC(callback_view_freshclam_log),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"View gclamp.log",
                            accel_group, (char *)"^G", 
  			                    tooltips, (char *)"View \"gclamp.log\" in gclamp's home directory,\n"
                                              "usually \"~/gclamp/gclamp.log\" unless restarted as root",
  			                    GTK_SIGNAL_FUNC(callback_view_gclamp_log),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"View gclamp.defaults",
                            accel_group, (char *)"", 
  			                    tooltips, (char *)"View \"gclamp.defaults\" in gclamp's home directory,\n"
                                              "usually \"~/gclamp/gclamp.defaults\" unless restarted as root",
  			                    GTK_SIGNAL_FUNC(callback_view_gclamp_defaults),
			                      (gpointer)this);


// HELP

menu = create_bar_submenu(menubar, (char *)"Help");

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Browse Documentation",
                            accel_group, (char *)"^B", 
  			                    tooltips, (char *)"Browse the HTML documentation\n",
  			                    GTK_SIGNAL_FUNC(callback_browse),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"About",
                            accel_group, (char *)"^A", 
  			                    tooltips, (char *)"About this program", 
  			                    GTK_SIGNAL_FUNC(callback_about),
			                      (gpointer)this);

table = gtk_table_new(400, 350, TRUE);   // rows, columns, homogeneous
gtk_box_pack_start(GTK_BOX(widget), table, TRUE, TRUE, 0);  // box, child, expand, fill, pad

notebook = gtk_notebook_new ();


gtk_notebook_set_tab_pos (GTK_NOTEBOOK(notebook), GTK_POS_TOP);
gtk_table_attach(GTK_TABLE(table), notebook, 0, 350, 0, 380, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

widget = add_page(notebook, (gchar *)"Actions");
fill_action_page(widget);

widget = add_page(notebook, (gchar *)"Directories to Scan");
fill_directories_page(widget);

widget = add_page(notebook, (gchar *)"Directories to Omit");
fill_directories_omit_page(widget);

widget = add_page(notebook, (gchar *)"Files to Scan");
fill_files_page(widget);

widget = add_page(notebook, (gchar *)"Files to Omit");
fill_files_omit_page(widget);

widget = add_page(notebook, (gchar *)"Options");
fill_options_page(widget);

save_image = gtk_image_new_from_pixbuf (
                                        gdk_pixbuf_new_from_inline(-1,
                                          save_pixbuf_src,
					                                FALSE, NULL)
                                        );
load_image = gtk_image_new_from_pixbuf (
                                        gdk_pixbuf_new_from_inline(-1,
                                          load_pixbuf_src,
					                                FALSE, NULL)
                                        );

box = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(box), GTK_BUTTONBOX_EDGE);
gtk_box_set_spacing(GTK_BOX(box), 10);
gtk_table_attach(GTK_TABLE(table), box, 0, 350, 380, 400, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

//  SAVE DEFAULTS BUTTON
widget = gtk_button_new_with_mnemonic("SAVE _DEFAULTS");
decorate_button(GTK_WIDGET(widget), &lightgreen,  &lightyellow, NULL);        
gtk_button_set_image(GTK_BUTTON(widget), save_image);   // This used to work but not any more...
gtk_widget_show(GTK_WIDGET(save_image));
g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_save_defaults), (gpointer)this);
gtk_container_add(GTK_CONTAINER(box), widget);

//  LOAD DEFAULTS BUTTON
widget = gtk_button_new_with_mnemonic("_LOAD DEFAULTS");
gtk_button_set_image(GTK_BUTTON(widget), load_image);
gtk_widget_show(GTK_WIDGET(load_image));
decorate_button(GTK_WIDGET(widget), &lightblue,  &lightyellow, NULL);       

g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_load_defaults), (gpointer)this);
gtk_container_add(GTK_CONTAINER(box), widget);



callback_load_defaults(widget, this); // as if "LOAD DEFAULTS" button was clicked...
 

//  QUIT BUTTON
widget = gtk_button_new_with_mnemonic("_QUIT");
gtk_button_set_image(GTK_BUTTON(widget), gtk_image_new_from_stock(GTK_STOCK_QUIT, GTK_ICON_SIZE_BUTTON)); 
decorate_button(GTK_WIDGET(widget), &pink,  &lightyellow, NULL);       

// Make sure the image is displayed!
gtk_widget_show(GTK_WIDGET(gtk_button_get_image(GTK_BUTTON(widget)))); 

g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_quit), (gpointer)this);
gtk_container_add(GTK_CONTAINER(box), widget);


gtk_widget_show_all(window);

// Check now and once an hour thereafter
check_database(this);

db_timer = g_timeout_add_seconds(60*60, check_database, this);


// Testing... Looks OK
//busy = 1;
//start_timer(this);

//cout << "Gclamp: - do_scan_all = " <<  do_scan_all << endl;
gtk_main ();
}


GtkWidget *Gclamp::add_page(GtkWidget *notebook, gchar *title)
{
GtkWidget *label;
GtkWidget *vbox;

vbox = gtk_vbox_new(FALSE, 0);
gtk_widget_show (vbox);

label = gtk_label_new(title);
gtk_notebook_append_page(GTK_NOTEBOOK (notebook), vbox, label);
return(vbox);
}

void Gclamp::fill_action_page(GtkWidget *vbox)
{
GtkWidget *widget, *table, *vbbox, *hbbox;

table = gtk_table_new(  380,     380,       TRUE      );
//                     rows,   columns,  homogeneous
gtk_container_add(GTK_CONTAINER(vbox), table);

gclamp_image = gtk_image_new();
widget = gtk_event_box_new();
gtk_event_box_set_above_child(GTK_EVENT_BOX(widget), FALSE);
gtk_container_add(GTK_CONTAINER(widget), gclamp_image);
gtk_table_attach(GTK_TABLE(table), widget, 0, 90, 0, 90,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);
gtk_image_set_from_pixbuf(GTK_IMAGE(gclamp_image), icon_pixbuf);
gtk_misc_set_alignment(GTK_MISC (gclamp_image), 0, .5); // left


warning_label = gtk_label_new("");
gtk_misc_set_alignment(GTK_MISC (warning_label), 0, .5); // left
gtk_widget_modify_fg(GTK_WIDGET(warning_label), GTK_STATE_NORMAL, &red);
gtk_table_attach(GTK_TABLE(table), warning_label, 90, 380, 5, 30,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


status_label = gtk_label_new("");
gtk_misc_set_alignment(GTK_MISC (status_label), 0, .5); // left
gtk_widget_modify_fg(GTK_WIDGET(status_label), GTK_STATE_NORMAL, &blue);
gtk_table_attach(GTK_TABLE(table), status_label, 90, 380, 30, 55,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

db_status_label = gtk_label_new("");
gtk_misc_set_alignment(GTK_MISC (db_status_label), 0, .5); // left
gtk_table_attach(GTK_TABLE(table), db_status_label,90, 380, 55, 80,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


current_file_label = gtk_label_new("");
gtk_misc_set_alignment(GTK_MISC (current_file_label), 0, .5); // left
gtk_table_attach(GTK_TABLE(table), current_file_label, 0, 380, 90, 115,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


widget = gtk_label_new("Scanned Files:");
gtk_misc_set_alignment(GTK_MISC (widget), 0, .5); // left
    gtk_table_attach(GTK_TABLE(table), widget, 0, 90, 115, 140,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);
 
scanned_label = gtk_label_new("0");
num_scanned = 0;
gtk_misc_set_alignment(GTK_MISC (scanned_label), 0, .5); // left
gtk_table_attach(GTK_TABLE(table), scanned_label, 90, 380, 115, 140,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


widget = gtk_label_new("Infected Files:");
gtk_misc_set_alignment(GTK_MISC (widget), 0, .5); // left
gtk_table_attach(GTK_TABLE(table), widget, 0, 90, 140, 165,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

infected_label = gtk_label_new("0");
num_infected = 0;
gtk_misc_set_alignment(GTK_MISC (infected_label), 0, .5); // left
gtk_table_attach(GTK_TABLE(table), infected_label, 90, 380, 140, 165,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

gtk_widget_modify_fg(GTK_WIDGET(infected_label), GTK_STATE_NORMAL, &black);

hbbox = gtk_hbox_new(TRUE, 0);
gtk_table_attach(GTK_TABLE(table), hbbox, 0, 130, 165, 370,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

vbbox = gtk_vbox_new(TRUE, 5);
gtk_box_pack_start(GTK_BOX(hbbox), vbbox, FALSE, TRUE, 0);
  
widget = gtk_button_new_with_mnemonic("_UPDATE DATABASE");
decorate_button(GTK_WIDGET(widget), &lightbrown,  &lightyellow, NULL);       
gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), widget,
      "Update the ClamAV database",
      NULL);
g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_update_db), (gpointer)this);
gtk_container_add(GTK_CONTAINER(vbbox), widget);


widget = gtk_button_new_with_mnemonic("VIEW _Freshclam.log");
decorate_button(GTK_WIDGET(widget), &lightbrown,  &lightyellow, NULL);       
g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_view_freshclam_log), (gpointer)this);
gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), widget,
      "View log file /var/log/freshclam.log",
      NULL);
gtk_container_add(GTK_CONTAINER(vbbox), widget);


widget = gtk_button_new_with_mnemonic("VIEW _Gclamp.log");
decorate_button(GTK_WIDGET(widget), &lightbrown,  &lightyellow, NULL);       
g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_view_gclamp_log), (gpointer)this);
gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), widget,
      "View \"gclamp.log\" in gclamp's home directory,\n"
      "usually \"~/gclamp/gclamp.log\" unless restarted as root",
      NULL);
gtk_container_add(GTK_CONTAINER(vbbox), widget);

    
 
    
    
if ( (strcmp( (getpwuid( getuid() ))->pw_name , "root" )) ) // if we are not root
  {
  widget = gtk_button_new_with_mnemonic("_RESTART as root");
  decorate_button(GTK_WIDGET(widget), &lightbrown,  &lightyellow, NULL);       
  g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_restart_as_root), (gpointer)this);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), widget,
      "Restart gclamp as root user",
      NULL);
  gtk_container_add(GTK_CONTAINER(vbbox), widget);
  }
else
  {
  string text = "ROOT - using:\n\"" + home_directory + "\"";
  widget = gtk_label_new(text.c_str());
  gtk_misc_set_alignment(GTK_MISC (widget), 0, .5); // left
  gtk_widget_modify_fg(GTK_WIDGET(widget), GTK_STATE_NORMAL, &blue);
  gtk_container_add(GTK_CONTAINER(vbbox), widget);
  }

widget = gtk_button_new_with_mnemonic("_SCAN");
decorate_button(GTK_WIDGET(widget), &lightbrown,  &lightyellow, NULL);       
g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_scan), (gpointer)this);
gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), widget,
      "Scan selected directories and files",
      NULL);
gtk_container_add(GTK_CONTAINER(vbbox), widget);

widget = gtk_button_new_with_mnemonic("_COMPLETE SCAN");
decorate_button(GTK_WIDGET(widget), &lightbrown,  &lightyellow, NULL);       
g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (callback_scan_all), (gpointer)this);
gtk_tooltips_set_tip (GTK_TOOLTIPS (tooltips), widget,
      ( (strcmp( (getpwuid( getuid() ))->pw_name , "root" )) )
      ?
      "Restart as root and scan whole computer" // if we are not root
      :
      "Scan ALL directories and files", // if we are root
      NULL);
gtk_container_add(GTK_CONTAINER(vbbox), widget);


GtkWidget *sw = gtk_scrolled_window_new (NULL, NULL);;
gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
             GTK_SHADOW_ETCHED_IN);
gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
              GTK_POLICY_AUTOMATIC,
              GTK_POLICY_AUTOMATIC);


summary_label = gtk_label_new(summary.c_str());
gtk_misc_set_alignment(GTK_MISC (summary_label), 1, .0); // right

gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(sw), summary_label);

gtk_table_attach(GTK_TABLE(table), sw, 130, 380, 165, 370,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

}





void Gclamp::fill_directories_page(GtkWidget *vbox)
{
GtkWidget *widget, *table;
frd = new Requester;
frd->set_title1("CHOOSE DIRECTORIES");
frd->set_title2("CHOSEN DIRECTORIES");
//frd->set_button_colour(&lightbrown);
frd->set_decorate_buttons(&lightbrown, &lightyellow, GTK_STOCK_CANCEL, GTK_STOCK_OK);

table = gtk_table_new(  350,     380,       TRUE      );
//                     rows,   columns,  homogeneous
gtk_container_add(GTK_CONTAINER(vbox), table);


widget = frd->file_window(window, reqtype(REQ_DIRECTORIES), GTK_SELECTION_MULTIPLE);  
gtk_table_attach(GTK_TABLE(table), widget, 0, 380, 0, 370,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

}

void Gclamp::fill_directories_omit_page(GtkWidget *vbox)
{
GtkWidget *widget, *table;
frd_omit = new Requester;
frd_omit->set_title1("CHOOSE DIRECTORIES (OMIT)");
frd_omit->set_title2("CHOSEN DIRECTORIES (OMIT)");
  
frd_omit->set_recursive_not_included();

frd->set_decorate_buttons(&lightbrown, &lightyellow, GTK_STOCK_CANCEL, GTK_STOCK_OK);

table = gtk_table_new(  350,     380,       TRUE      );
//                     rows,   columns,  homogeneous
gtk_container_add(GTK_CONTAINER(vbox), table);


widget = frd_omit->file_window(window, reqtype(REQ_DIRECTORIES), GTK_SELECTION_MULTIPLE);

gtk_table_attach(GTK_TABLE(table), widget, 0, 380, 0, 370,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);
}


void Gclamp::fill_files_page(GtkWidget *vbox)
{
GtkWidget *widget, *table;
frf = new Requester;
frf->set_title1("CHOOSE FILES");
frf->set_title2("CHOSEN FILES");
frf->set_decorate_buttons(&lightbrown, &lightyellow, GTK_STOCK_CANCEL, GTK_STOCK_OK);

table = gtk_table_new(  350,     380,       TRUE      );
//                     rows,   columns,  homogeneous
gtk_container_add(GTK_CONTAINER(vbox), table);


widget = frf->file_window(window, reqtype(REQ_FILES), GTK_SELECTION_MULTIPLE);  
gtk_table_attach(GTK_TABLE(table), widget, 0, 380, 0, 370,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

}

void Gclamp::fill_files_omit_page(GtkWidget *vbox)
{
GtkWidget *widget, *table;
frf_omit = new Requester;
frf_omit->set_title1("CHOOSE FILES (OMIT)");
frf_omit->set_title2("CHOSEN FILES (OMIT)");
frf->set_decorate_buttons(&lightbrown, &lightyellow, GTK_STOCK_CANCEL, GTK_STOCK_OK);

table = gtk_table_new(  350,     380,       TRUE      );
//                     rows,   columns,  homogeneous
gtk_container_add(GTK_CONTAINER(vbox), table);


widget = frf_omit->file_window(window, reqtype(REQ_FILES), GTK_SELECTION_MULTIPLE);  
gtk_table_attach(GTK_TABLE(table), widget, 0, 380, 0, 370,  // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

}


void Gclamp::fill_options_page(GtkWidget *vbox)
{
GtkWidget *box, *frame, *widget;
GtkWidget *table = gtk_table_new(  410,     380,       TRUE      );
//                                rows,   columns,  homogeneous
GtkWidget *table2 = gtk_table_new( 40,       25,       TRUE      );;

gtk_container_add(GTK_CONTAINER(vbox), table);

frame = gtk_frame_new("Log");
gtk_table_attach(GTK_TABLE(table), frame, 0, 225, 0, 180, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


gtk_container_add(GTK_CONTAINER(frame), table2);

log_checkbutton = gtk_check_button_new_with_label("LOG");
gtk_signal_connect (GTK_OBJECT (log_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_log_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), log_checkbutton, 0, 7, 16, 24, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

log_append_checkbutton = gtk_check_button_new_with_label("Append");
gtk_signal_connect (GTK_OBJECT (log_append_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_log_group_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), log_append_checkbutton, 7, 25, 0, 8, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


log_overwrite_checkbutton = gtk_check_button_new_with_label("Overwrite");
gtk_signal_connect (GTK_OBJECT (log_overwrite_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_log_group_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), log_overwrite_checkbutton, 7, 25, 8, 16, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

log_include_empty_checkbutton = gtk_check_button_new_with_label("Include empty files");
gtk_table_attach(GTK_TABLE(table2), log_include_empty_checkbutton, 7, 25, 16, 24, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


log_include_OK_checkbutton = gtk_check_button_new_with_label("Include OK files");
gtk_table_attach(GTK_TABLE(table2), log_include_OK_checkbutton, 7, 25, 24, 32, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

log_include_excluded_checkbutton = gtk_check_button_new_with_label("Include excluded files");
gtk_table_attach(GTK_TABLE(table2), log_include_excluded_checkbutton, 7, 25, 32, 40, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);




// Move Copy or Remove infected files
frame = gtk_frame_new("Infected Files");
gtk_table_attach(GTK_TABLE(table), frame, 225, 380, 0, 145, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

table2 = gtk_table_new( 32,       20,       TRUE      );;
//                      rows,   columns,  homogeneous

gtk_container_add(GTK_CONTAINER(frame), table2);

move_checkbutton = gtk_check_button_new_with_label("MOVE infected files to Quarantine");
gtk_signal_connect (GTK_OBJECT (move_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_move_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), move_checkbutton, 0, 20, 0, 10, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


copy_checkbutton = gtk_check_button_new_with_label("COPY infected files to Quarantine");
gtk_signal_connect (GTK_OBJECT (copy_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_copy_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), copy_checkbutton, 0, 20, 10, 20, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

delete_checkbutton = gtk_check_button_new_with_label("DELETE infected files");
gtk_signal_connect (GTK_OBJECT (delete_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_delete_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), delete_checkbutton, 0, 20, 20, 30, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

ignore_checkbutton = gtk_check_button_new_with_label("LEAVE infected files alone");
gtk_signal_connect (GTK_OBJECT (ignore_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_ignore_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), ignore_checkbutton, 0, 20, 30, 40, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);



widget = gtk_label_new("Browser: ");
gtk_misc_set_alignment(GTK_MISC(widget), 1, .5); // right
gtk_table_attach(GTK_TABLE(table), widget,  225, 275, 145, 180, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);
	
browser_entry = gtk_entry_new();
gtk_table_attach(GTK_TABLE(table), browser_entry,  275, 380, 145, 180, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);







frame = gtk_frame_new("To become \"root\" use:-");
gtk_table_attach(GTK_TABLE(table), frame,  10, 370, 180, 270, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

	table2 = gtk_table_new( 31,       20,       TRUE      );;
//                      rows,   columns,  homogeneous

gtk_container_add(GTK_CONTAINER(frame), table2);


susudo_checkbutton = gtk_check_button_new_with_label("su and sudo");
gtk_signal_connect (GTK_OBJECT (susudo_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_su_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), susudo_checkbutton, 1, 5, 1, 14, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


su_checkbutton = gtk_check_button_new_with_label("su");
gtk_signal_connect (GTK_OBJECT (su_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_su_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), su_checkbutton, 8, 12, 1, 14, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


sudo_checkbutton = gtk_check_button_new_with_label("sudo");
gtk_signal_connect (GTK_OBJECT (sudo_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_su_checkbutton_clicked), this);
gtk_table_attach(GTK_TABLE(table2), sudo_checkbutton, 15, 19, 1, 14, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);


frame = gtk_frame_new("Virus Database");
gtk_table_attach(GTK_TABLE(table), frame, 10, 370, 270, 370, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
       (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

table2 = gtk_table_new( 20,       20,       TRUE      );;
//                      rows,   columns,  homogeneous

gtk_container_add(GTK_CONTAINER(frame), table2);

widget = gtk_label_new("WARN db needs update after ");
gtk_misc_set_alignment(GTK_MISC (widget), 1, .5); // right
gtk_table_attach(GTK_TABLE(table2), widget, 0, 10, 0, 10, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

db_warn_spinner = create_spinner(1, 1, 14);
gtk_table_attach(GTK_TABLE(table2), db_warn_spinner, 10, 12, 0, 10, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

widget = gtk_label_new("day(s)");
gtk_misc_set_alignment(GTK_MISC (widget), 0, .5); // left
  gtk_table_attach(GTK_TABLE(table2), widget, 12, 20, 0, 10, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

box = gtk_hbox_new(  FALSE,      0);
//                 homogeneous spacing
gtk_table_attach(GTK_TABLE(table2), box, 0, 10, 10, 20, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

auto_update_checkbutton = gtk_check_button_new_with_label("Auto update after ");
gtk_box_pack_end(GTK_BOX(box), auto_update_checkbutton, FALSE, FALSE, 0);
gtk_signal_connect (GTK_OBJECT (auto_update_checkbutton), "clicked",
            GTK_SIGNAL_FUNC (callback_auto_update_checkbutton_clicked), this);

auto_update_spinner = create_spinner(1, 1, 14);
gtk_table_attach(GTK_TABLE(table2), auto_update_spinner, 10, 12, 10, 20, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);

widget = gtk_label_new("day(s)");
gtk_misc_set_alignment(GTK_MISC (widget), 0, .5); // left
gtk_table_attach(GTK_TABLE(table2), widget, 12, 20, 10, 20, // L, R, T, B
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
        (GtkAttachOptions)(GTK_FILL | GTK_EXPAND), 5, 5);
}

GtkWidget *Gclamp::create_bar_submenu (GtkWidget *menubar, char *name)
{
GtkWidget *menuitem;
GtkWidget *submenu;
 
menuitem = gtk_menu_item_new_with_label (name);

gtk_menu_bar_append (GTK_MENU_BAR (menubar), menuitem);
gtk_widget_show (menuitem);

submenu = gtk_menu_new ();
gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem), submenu);

return (submenu);
}

GtkWidget *Gclamp::create_menuitem (GtkWidget *window,
                            GtkWidget *menu, 
				                    char *name,
                            GtkAccelGroup *accel_group,
				                    char *accel,
                            GtkTooltips *tooltips,
				                    char *tip, 
				                    GtkSignalFunc func,
				                    gpointer data)
{
GtkWidget *menuitem;
if (name && strlen (name))
  {
  menuitem = gtk_menu_item_new_with_label (name);
  gtk_signal_connect (GTK_OBJECT (menuitem),
                      "activate",
                      GTK_SIGNAL_FUNC(func), data);
  }
else
  {
  menuitem = gtk_menu_item_new ();
  }
gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
gtk_widget_show (menuitem);

if (accel_group == NULL) 
  {
  accel_group = gtk_accel_group_new ();
	gtk_window_add_accel_group(GTK_WINDOW(window), GTK_ACCEL_GROUP(accel_group));
  }

if (accel && accel[0] == '^')
  {
  gtk_widget_add_accelerator (menuitem, 
                              "activate", 
                              accel_group,
                              accel[1], 
                              GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  }

if (tip && strlen (tip))
  {
  gtk_tooltips_set_tip (tooltips, menuitem, tip, NULL);
  }

return (menuitem);
}

